{
        Program Name : MITS_Altair
        Package Name : CEF
        Purpose      : MITS Altair 8800 CEF component main form
        Institution  : Conroy & Conroy Co.
        Date Written :
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 2007 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

}

unit Altair_Form ;

interface

uses // Borland...
     Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
     Dialogs, StdCtrls, ExtCtrls, Menus ;

type
  TFront_Panel_Form = class(TForm)
    Control_Box: TGroupBox;
    Data_Box: TGroupBox;
    Address_Box: TGroupBox;
    Read_LED: TShape;
    Write_LED: TShape;
    Label1: TLabel;
    Label2: TLabel;
    Memory_LED: TShape;
    IO_LED: TShape;
    Label3: TLabel;
    Label4: TLabel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    IMSAI_Panel: TPanel;
    Options1: TMenuItem;
    Emulation1: TMenuItem;
    Altair1: TMenuItem;
    IMSAI1: TMenuItem;
    Debug1: TMenuItem;
    Ports1: TMenuItem;
    procedure FormResize(Sender: TObject);
    procedure IMSAI1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Debug1Click(Sender: TObject);
    procedure Ports1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

  private // Instance data...

  public
    { Public declarations }
  end ;

implementation

uses // CEF...
     CEF, // TUI_Interface

     // Altair...
     MITS_Altair, // _UI
     Port_Dialog ; // TPort_Form

{$R *.dfm}

procedure TFront_Panel_Form.FormResize( Sender : TObject ) ;

var Control : TControl ;
    Dummy, Loop : integer ;

begin
    Dummy := Control_Box.Width ;
    Control_Box.Width := ClientWidth - COntrol_Box.Left * 2 ;
    Address_Box.Width := Control_Box.Width ;
    Data_Box.Width := Control_Box.Width ;
    Dummy := Control_Box.Width - Dummy ; // Difference in width
    for Loop := 0 to Data_Box.ControlCount - 1 do
    begin
        Control := Data_Box.Controls[ Loop ] ;
        Control.Left := Control.Left + Dummy ;
    end ;
    for Loop := 0 to Address_Box.ControlCount - 1 do
    begin
        Control := Address_Box.Controls[ Loop ] ;
        Control.Left := Control.Left + Dummy ;
    end ;
end ;



procedure TFront_Panel_Form.IMSAI1Click(Sender: TObject);

begin
    TMenuItem( Sender ).Checked := True ;
    IMSAI_Panel.Visible := IMSAI1.Checked ;
    if( IMSAI1.Checked ) then
    begin
        Caption := 'IMSAI 8080' ;
    end else
    begin
        Caption := 'Altair 8800' ;
    end ;
end ;


procedure TFront_Panel_Form.Exit1Click(Sender: TObject);

begin
    _Altair._User_Interface._UI.Terminate ;
end ;


procedure TFront_Panel_Form.Debug1Click(Sender: TObject);

begin
    _Altair._User_Interface._UI.Hide( True ) ;
end ;


procedure TFront_Panel_Form.Ports1Click( Sender : TObject ) ;

    procedure Delete_Port( Loop : integer ) ;

    begin
        if( Port_Components[ True, Loop ] <> nil ) then
        begin
            Port_Components[ True, Loop ].Terminate ;
            FreeLibrary( Port_Component_Handles[ True, Loop ] ) ;
            Port_Components[ True, Loop ] := nil ;
        end ;
        if( Port_Components[ False, Loop ] <> nil ) then
        begin
            Port_Components[ False, Loop ].Terminate ;
            FreeLibrary( Port_Component_Handles[ False, Loop ] ) ;
            Port_Components[ False, Loop ] := nil ;
        end ;
        if( Port_Components[ True, Loop + 1 ] <> nil ) then
        begin
            Port_Components[ True, Loop + 1 ].Terminate ;
            FreeLibrary( Port_Component_Handles[ True, Loop + 1 ] ) ;
            Port_Components[ True, Loop + 1 ] := nil ;
        end ;
        if( Port_Components[ False, Loop + 1 ] <> nil ) then
        begin
            Port_Components[ False, Loop + 1 ].Terminate ;
            FreeLibrary( Port_Component_Handles[ False, Loop + 1 ] ) ;
            Port_Components[ False, Loop + 1 ] := nil ;
        end ;
    end ;

var C : TComponent ;
    Dlg : TPort_Form ;
    Dummy, Loop : integer ;
    H : THandle ;
    P : function( Serial_Number : integer ; UI : TUI_Interface ) : TComponent ; stdcall ;
    S, S1 : string ;

begin
    Dlg := TPort_Form.Create( Application ) ;
    try
        Dlg.Define( 255, True, '* Panel switches' ) ;
        if( IMSAI1.Checked ) then
        begin
            Dlg.Define( 255, False, '* Panel LEDs' ) ;
        end ;
        for Loop := 0 to 255 do
        begin
            if( Port_Components[ True, Loop ] <> nil ) then
            begin
                S := string( Port_Components[ True, Loop ].Name ) ;
                if( S = 'MITS 88-SIO' ) then
                begin
                    S := S + ' port ' + inttostr( Loop div 2 ) ;
                    Dlg.Define( Loop, True, S + ' Status' ) ;
                    Dlg.Define( Loop, False, S + ' Status' ) ;
                    if( Port_Connections[ True, Loop ] <> nil ) then
                    begin
                        S1 := ' -> ' + string( Port_Connections[ True, Loop ].Name ) ;
                    end else
                    begin
                        S1 := '' ;
                    end ;
                    Dlg.Define( Loop + 1, True, S + ' Input channel' + S1 ) ;
                    if( Port_Connections[ False, Loop ] <> nil ) then
                    begin
                        S1 := ' -> ' + string( Port_Connections[ False, Loop ].Name ) ;
                    end else
                    begin
                        S1 := '' ;
                    end ;
                    Dlg.Define( Loop + 1, False, S + ' Output channel' + S1 ) ;
                    continue ;
                end ;
                Dlg.Define( Loop, True, S ) ;
            end ;
            if( Port_Components[ False, Loop ] <> nil ) then
            begin
                Dlg.Define( Loop, False, string( Port_Components[ True, Loop ].Name ) ) ;
            end ;
        end ;
        if( Dlg.ShowModal = mrOK ) then
        begin
            Loop := 0 ;
            while( Loop <= 255 ) do
            begin
                S := Dlg.Defined( True, Loop ) ;
                if( copy( S, 1, 17 ) = 'MITS 88-SIO port ' ) then
                begin
                    if(
                        ( Port_Components[ True, Loop ] = nil ) // Added port
                        or
                        ( Port_Components[ True, Loop ].Name <> 'MITS 88-SIO' ) // Replaced one port with a serial port
                      ) then
                    begin
                        Delete_Port( Loop ) ; // Delete existing port

                        // Create new serial port
                        H := LoadLibrary( 'SIO.DLL' ) ;
                        C := nil ;
                        if( H <> 0 ) then
                        begin
                            P := GetProcAddress( H, 'Make_Instance' ) ;
                            if( assigned( P ) ) then
                            begin
                                C := P( 0, _Altair._User_Interface._UI ) ;
                            end else
                            begin
                                H := 0 ;
                            end ;
                        end ;
                        Port_Component_Handles[ True, Loop ] := H ;
                        Port_Components[ True, Loop ] := C ;
                        C.Memory.Set_Address_Range( Loop, Loop + 1 ) ;
                    end ; // if

                    S := Dlg.Defined( True, Loop + 1 ) ;
                    Dummy := pos( ' -> ', S ) ;
                    if( Dummy = 0 ) then // No port connection
                    begin
                        if( Port_Connections[ True, Loop ] <> nil ) then // Remove existing port connection
                        begin
                            Port_Connections[ True, Loop ].Terminate ;
                            Port_Connections[ True, Loop ] := nil ;
                        end ;
                    end else
                    begin
                        // Connection was specified in dialog...
                        S := copy( S, Dummy + 4, length( S ) ) ; // Get connection name
                        if( Port_Connections[ True, Loop ] <> nil ) then
                        begin
                            if( string( Port_Connections[ True, Loop ].Name ) <> S ) then
                            begin // Current connection is different than dialog, so delete current
                                Port_Connections[ True, Loop ].Terminate ;
                                Port_Connections[ True, Loop ] := nil ;
                            end ;
                        end ;
                        if( Port_Connections[ True, Loop ] = nil ) then // Need to connect
                        begin
                            // Load port connection component...
                            H := LoadLibrary( PChar( Dlg.Connections[ Loop + 1 ] ) ) ;
                            C := nil ;
                            if( H <> 0 ) then
                            begin
                                P := GetProcAddress( H, 'Make_Instance' ) ;
                                if( assigned( P ) ) then
                                begin
                                    C := P( 0, _Altair._User_Interface._UI ) ;
                                end ;
                            end ;
                            Port_Connections[ True, Loop ] := C ;
                            C.Parent := _Altair ;

                            // Connect component to port...
                            Port_Components[ True, Loop ].Connect_Input( C ) ;
                            Port_Components[ True, Loop ].Connect_Output( C ) ;
                            C.Connect_Output( Port_Components[ True, Loop ] ) ;
                            C.Connect_Input( Port_Components[ True, Loop ] ) ;
                        end ;
                    end ;
                    Loop := Loop + 1 ;
                end else
                if( S = 'Unassigned' ) then // An unassigned port
                begin
                    if( Port_Components[ True, Loop ] <> nil ) then
                    begin
                        Delete_Port( Loop ) ; // Delete existing port
                    end ;
                end ;
                Loop := Loop + 1 ;
            end ; // while( Loop <= 255 )
        end ; // if( Dlg.ShowModal = mrOK )
    finally
        Dlg.Free ;
    end ;
end ; // TFront_Panel_Form.Ports1Click


procedure TFront_Panel_Form.FormClose( Sender : TObject ;
    var Action : TCloseAction ) ;

begin
    Action := caFree ;
end ;


end.

