unit CRC ;

{ This Cyclic Redundancy Check is based on C-source written by
  Daniel Blackman. }

interface

{ Calculate a 16-bit Cyclic Redundancy Code }
function CRC16( Buffer : string ) : word ;


implementation

function Byte_CRC( bl : byte ; ax : word ) : word ;

var W : word ;
    B : byte ;

begin
    Result := swap( Ax ) ;
    W := Result ;

    B := hi( Result ) xor bl ;
    B := B xor ( B div 16 ) ;

    Result := B shl 8 ;
    W := ( lo( W ) xor ( B * 16 ) ) + Result ;

    Result := ( Result * 32 ) xor W ;
end ; { Byte_CRC }


{ API... }

function CRC16( Buffer : string ) : word ;

var Loop : Integer ;

begin
    Result := $FFFF ;
    for Loop := 1 to length( Buffer ) do
    begin
        Result := Byte_CRC( byte( Buffer[ Loop ] ), Result ) ;
    end ;
end ;



end.
 
