{
        Program Name : DebugMa
        Package Name : LB
        Purpose      : Debug Manager default implementation
        Institution  : Conroy & Conroy Co.
        Date Written : 15-August-2003
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 2003 by Alan Conroy.  Released to the Public Domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          This unit contains the default Debug Manager.
}

unit DebugMa ;

interface

uses _DebugMa ; { TDebug_Manager }

{$I EDEFINES.INC}

function Debug_Manager : PSDebug_Manager ;
procedure Initialize_Unit ;

implementation

uses { C&C.. }
     _App, { Application_Manager }
     Collect ; { TCollection }

type TDefault_Debug_Manager = object( TSDebug_Manager )
				  public { Constructors and destructors... }
				      constructor Init ;
				      destructor Done ; virtual ;

				  private { Instance data... }
				      Collection : TCollection ;

	                          public { Unit debugger support... }
	                              function Get_Unit_Debugger( Index : longint ) : PSUnit_Debugger ;
	                                  virtual ;

	                              { Register a unit debugger }
	                              procedure Register_Unit_Debugger( D : PSUnit_Debugger ) ;
	                                  virtual ;

	                              { Remove a registered unit debugger }
	                              procedure Remove_Unit_Debugger( D : PSUnit_Debugger ) ;
	                                  virtual ;

	                              { Returns count of registered unit debuggers }
	                              function Unit_Debugger_Count : longint ;
	                                  virtual ;
	                      end ;

{ Constructors and destructors... }

constructor TDefault_Debug_Manager.Init ;

begin
    inherited Init ;

    Collection.Init( 0, 4 ) ;
end ;


destructor TDefault_Debug_Manager.Done ;

begin
    Collection.Done ;

    inherited Done ;
end ;


{ Unit debugger support... }

function TDefault_Debug_Manager.Get_Unit_Debugger( Index : longint ) : PSUnit_Debugger ;
 
begin
    Get_Unit_Debugger := PSUnit_Debugger( Collection.At( Index ) ) ;
end ;


{ Register a unit debugger }
procedure TDefault_Debug_Manager.Register_Unit_Debugger( D : PSUnit_Debugger ) ;

begin
    Collection.Insert( D ) ;
end ;


{ Remove a registered unit debugger }
procedure TDefault_Debug_Manager.Remove_Unit_Debugger( D : PSUnit_Debugger ) ;

begin
    Collection.Delete( D ) ;
end ;


{ Returns count of registered unit debuggers }
function TDefault_Debug_Manager.Unit_Debugger_Count : longint ;

begin
    Unit_Debugger_Count := Collection.Count ;
end ;


var _Debug_Manager : TDefault_Debug_Manager ;
{$IFDEF DELPHI}
    _DM_Initialized : boolean = False ;
{$ENDIF}

function Debug_Manager : PSDebug_Manager ;

begin
    Debug_Manager := @_Debug_Manager ;
end ;


procedure Initialize_Unit ;

begin
{$IFDEF DELPHI}
    if( _DM_Initialized ) then
    begin
        exit ;
    end ;
{$ENDIF}
    _Debug_Manager.Init ;
    if(
        ( Application_Manager <> nil )
        and
        ( Application_Manager.Debug_Manager = nil )
      ) then
    begin
        Application_Manager.Set_Debug_Manager( @_Debug_Manager ) ;
    end ;
{$IFDEF DELPHI}
    _DM_Initialized := True ;
{$ENDIF}
end ;


begin
    Initialize_Unit ;
end.
