{
        Program Name : O_S
        Package Name : LB
        Purpose      : Operating system interface
        Institution  : Conroy & Conroy Co.
        Date Written : 6-Nov-2002
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 2002 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *  Mar-07-2006   RBJ         Cleaned up memory leaks.       *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          This unit causes the proper TOperating_System object to be included
        in the application.
}

unit O_S ;

interface

uses _OS ; { POperating_System }

function OS : PSOperating_System ;
procedure Terminate ;

implementation

{$I EDEFINES.INC}

{$IFDEF DELPHI}
uses OS_Windows ; { TOS_Windows }
{$ELSE}
uses OS_DOS ; { TOS_DOS }
{$ENDIF}

{$IFDEF Delphi}
var __OS : PSOperating_System = nil ;
{$ELSE}
var __OS : PSOperating_System ;
{$ENDIF}

function OS : PSOperating_System ;

begin
    if( __OS = nil ) then
    begin
{$IFDEF Delphi}
        __OS := new( PSOS_Windows, Init ) ; { We don't ever deallocate since this is a singleton needed everywhere }
{$ELSE}
        __OS := new( POS_DOS, Init ) ; { We don't ever deallocate since this is a singleton needed everywhere }
{$ENDIF}
    end ;
    OS := __OS ;
end ;


{ Unit API... }

procedure Terminate ;

begin
    dispose( __OS, Done ) ;
    __OS := nil ;
end ;


{$IFNDEF Delphi}
begin
    __OS := nil ;

{$ELSE}
initialization

finalization
  {$IFDEF CC_Auto_Free_Operating_System}
      Terminate ;
  {$ENDIF}
{$ENDIF}

end.
