{
        Program Name : Streams
        Package Name : LB
        Purpose      : TSStream object
        Institution  : Conroy & Conroy Co.
        Date Written : 2002
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 2002-2003 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

}

unit Streams ;

interface

{$I EDEFINES.INC}

uses ComInter, { TCommon_COM_Object }
     Common, { TBase_Object }
     _Streams ; { TSStream }

type TBase_Stream = object( TSStream )
                        public { API... }
                           { Returns True if there is no more data in the stream to
                             read. }
                           function At_End : boolean ; virtual ;

                           { Reads the specified number of bytes from the stream.
                             Size is modified to be the actual bytes transferred. }
                           procedure Read( var Buffer ; var _Size : longint ) ;
                               virtual ;

                           { Reads one line of input, up to the size of the buffer.
                             The line is assumed to end at an ASCII 13 code.  The
                             ASCII 13 code is not included in the returned data.
                             Size is modified to be the actual bytes transferred. }
                           procedure Read_Line( var Buffer ; var _Size : longint ) ;
                               virtual ;

                           { Reads one line of input.  The line is assumed to end at
                             an ASCII 13 code.  The ASCII 13 code is not included in
                             the returned data. }
                           function Read_String : string ; virtual ;

                           { Position to specified byte within streamed data. }
                           procedure Seek( Position : longint ) ; virtual ;

                           { Writes the specified buffer, of the specified size in
                             bytes, to the stream. }
                           procedure Write( var Buffer ; _Size : longint ) ;
                               virtual ;

                           { Writes the specified string to the stream. }
                           procedure Write_String( const Buffer : string ) ;

                           { Writes the specified null-terminated text to the stream.
                             An ASCII code 13 is appended to the text on output. }
                           procedure Write_Line( Buffer : PChar ) ; virtual ;

                           { Writes the specified string to the stream.
                             An ASCII code 13 is appended to the text on output. }
                           procedure Write_Line_String( const Buffer : string ) ;
                               virtual ;
                    end ; { TBase_Stream }
     PBase_Stream = ^TBase_Stream ;

implementation

uses ASCIIDef, { CR }
     Compatib, { strlen }
     Typedefs ; { tByte_Array }

{ TBase_Stream methods... }

function TBase_Stream.At_End : boolean ;

begin
    At_End := True ;
end ;


procedure TBase_Stream.Read( var Buffer ; var _Size : longint ) ;

begin
    _Size := 0 ;
end ;


procedure TBase_Stream.Read_Line( var Buffer ; var _Size : longint ) ;

var C : char ;
    Index : longint ;
    S : integer ;

begin
    { Setup... }
    _Size := 0 ;
    Index := 0 ;

    while( not At_End ) do
    begin
        S := 1 ;
        Read( C, S ) ;
        if( ( C = CR ) or ( S = 0 ) ) then
        begin
            break ;
        end ;
        TByte_Array( Buffer )[ Index ] := byte( C ) ;
        inc( Index ) ;
        inc( _Size ) ;
    end ;
end ;


function TBase_Stream.Read_String : string ;

var C : char ;
    S : string ;
    Size : integer ;

begin
    S := '' ;
    while( not At_End ) do
    begin
        Size := 1 ;
        Read( C, Size ) ;
        if( ( C = CR ) or ( Size = 0 ) ) then
        begin
            break ;
        end ;
        S := S + C ;
    end ;
    Read_String := S ;
end ;


procedure TBase_Stream.Seek( Position : longint ) ;

begin
end ;


procedure TBase_Stream.Write( var Buffer ; _Size : longint ) ;

begin
end ;


procedure TBase_Stream.Write_String( const Buffer : string ) ;

var P : pointer ;

begin
    P := @Buffer[ 1 ] ;
    Write( P^, length( Buffer ) ) ;
end ;


procedure TBase_Stream.Write_Line( Buffer : PChar ) ;

var C : char ;

begin
    Write( Buffer, strlen( Buffer ) ) ;
    C := CR ;
    Write( C, 1 ) ;
end ;


procedure TBase_Stream.Write_Line_String( const Buffer : string ) ;

var C : char ;
    P : pointer ;

begin
    P := @Buffer[ 1 ] ;
    Write( P^, length( Buffer ) ) ;
    C := CR ;
    Write( C, 1 ) ;
end ;


end.
