{
	      Program Name : TEU
	      Package Name : LB
	      Purpose      : Text Editing Utility
	      Institution  : Conroy & Conroy
	      Original Vers: 22-Mar-89
	      Date Written : 21-Jul-1990
	      Written By   : Alan Conroy
	      Version      : 2.3B

              Copyright (C) 1989-1990 by Alan Conroy.  Released to the public domain.

	      TO THE GLORY OF GOD THROUGH JESUS CHRIST

	*********************************************************
	*                                                       *
	*        M O D I F I C A T I O N   H I S T O R Y        *
	*                                                       *
	*     DATE      BY             REASON                   *
	*                                                       *
	*  2-Nov-1999	EAC	2.3: Autoselect screen height.	*
	*  9-Nov-2002   EAC     Use EDEFINES.INC		*
	* 29-Jan-2003   EAC     Support Load/Store.             *
	*							*
	*********************************************************

	*********************************************************
	*                                                       *
	*           P R O G R A M   P U R P O S E               *
	*                                                       *
	*********************************************************

	  General text editor.
}

{$IFDEF MSDOS}
{$DEFINE MSDOS_OR_DPMI}
{$ENDIF}
{$IFDEF DPMI}
{$DEFINE MSDOS_OR_DPMI}
{$ENDIF}

unit Teu ;

interface

procedure Teu_Teu( Command : string ) ; { Main routine }

implementation

{$I EDEFINES.INC}

{$IFDEF DELPHI}
uses Windows,
{$ELSE}
    {$IFDEF WINDOWS}
uses WinDOS, WinProcs,
    {$ELSE}
uses WinDOS, DOS,
    {$ENDIF}
{$ENDIF}
     ASCIIDef,
     CommonUt, { FEdit }
     Standard, Files, Getchars, SMU, UEditor, Num1s, TypeDefs,
     Parse, Helps, Compatib,
     Dates, { Date }
     O_S, { OS }
     _Types ; { Small_String }

type pKeystrokes = ^tKeystrokes ;
     tKeystrokes = record
			Buffer : shortstring ;
			Offset : integer ;
			Next : pKeystrokes ;
		   end ;

     pKey_Definition = ^tKey_Definition ;
     tKey_Definition = record
			  Routine : integer ;
			  Parameters : ^shortString ;
			  Definition : pKeystrokes ;
		      end ;

     pKey_Definition_Array = ^tKey_Definition_Array ;
     tKey_Definition_Array = array[ 0..255 ] of pKey_Definition ;

const Version = '2.5' ;
const Window_Width = 80 ; { Temp }

      Translation : Translation_Type = ( '<NUL>', '<SOH>', '<STX>', '<ETX>', '', '<ENQ>',
{6}                           '<ACK>', '<BEL>', '<BS>', ' ', '<LF>', '<VT>', '<FF>',
{13}                          '<CR>', '<SO>', '<SI>', '<DLE>', '<DC1>', '<DC2>',
{19}                          '<DC3>', #20, '', '<SYN>', '<ETB>', '<CAN>', '<EM>',
{26}                          '<SUB>', '<ESC>', '<FS>', '<GS>', '<RS>', #31, ' ', '!',
{34}                          '"', '#', '$', '%', '&', #39, '(', ')', '*', '+', ',', '-',
{46}                          '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
{58}                          ':', ';', '<', '=', '>', '?', '@', 'A', 'B', 'C', 'D', 'E',
{70}                          'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q',
{82}                          'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', '\', ']',
{94}                          '^', '_', '`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i',
{106}                         'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u',
{118}                         'v', 'w', 'x', 'y', 'z', '{', '|', '}', #126, '<DEL>',
{128}                         '', '', '', '', '', '', '', '', '', '',
{138}                         '', '', '', '', '', '', '', '', '', '',
{148}                         '', '', '', '', '', '', '', '', '', '',
{158}                         '', '', '', '', '', '', '', '', '', '',
{168}                         '', '', '', '', '', '', '', '', '', '',
{178}                         '', '', '', '', '', '', '', '', '', '',
{188}                         '', '', '', '', '', '', '', '', '', '',
{198}                         '', '', '', '', '', '', '', '', '', '',
{208}                         '', '', '', '', '', '', '', '', '', '',
{218}                         '', '', '', '', '', '', '', '', '', '',
{228}                         '', '', '', '', '', '', '', '', '', '',
{238}                         '', '', '', '', '', '', '', '', '', '',
{248}                         '', '', '', '', '', '', '<EBS>', '<255>' ) ;

var  A : Integer ; { Loop and dummy variables }
     Ccl : Boolean ; { If a command-line entry }
     Character : string ;
     Character_Buffer : char ;
     Command : string ; { Input or command line }
     Deleted_Character : Boolean ; { True if a deleted character }
     Deleted_Line : Boolean ; { True if a deleted line }
     Deleted_Word : Boolean ; { True if a deleted word }
     Dummy : Integer ; { Dummy variable }
     Editor : pEditor ;
     Error_Flag : boolean ;
     Help_File_Name : string ;
     Init_File : Text ;
     Input_File : Text ;
     Input_Name, Journal_Name : string ; { Names of files }
     Iterate : Longint ; { Number of iterations, etc }
{$IFNDEF Simple}
     Journal : file of Small_string ; { Journal file }
     Journal_Buffer : Small_string ; { Contents of current record in journal file }
     Journal_Offset : Byte ; { Current offset in Journal_Buffer }
     Journal_Record : Longint ; { Current record in journal file }
     Journal_Size : Integer ; { Number of characters between journal file updates }
     Key_Commands : array[ 0..9 ] of pKey_Definition_Array ;
     { Key command translations }
     Key_Input : pKeystrokes ; { Keystrokes being stored for current learn }
     Current_Key_Input : pKeystrokes ; { Current keystroke input buffer }
     Key_Output : integer ; { Keystroke buffer being played }
     Current_Key_Output : pKeystrokes ; { Current keystroke output buffer }
{$ENDIF}
     Line_Buffer : string ;
     New_File : Boolean ;
     Paste_Buffer : pLine_Buffer ;
     Read_Only : boolean ; { True if /READ_ONLY }
{$IFNDEF Simple}
     Recover : Boolean ; { True if /RECOVER }
     Recover_Terminating : boolean ;
     { True if /RECOVER has terminated (so we can abort any multi-key
      sequences) }
{$ENDIF}
     Screen_Height : integer ; { Height of entire screen }
     Search_Text : string ;
     Status : boolean ;
     Status_Window, Error_Window : PWindow ;
     Word_Buffer : string ;

procedure Message_Beep ; { Sound a tone }

begin
    if( ( Editor^.Options and eds_Beep ) = eds_Beep ) then
    begin
	MessageBeep( 0 ) ;
    end ;
end ;


function File_Name( const X : string ) : string ; { Wrapper for FILNAM }

var XX : string ;

begin
    XX := Filnam( X, False ) ;
    if length( XX ) = 0 then
    begin
	XX := X ;
    end ;
    File_Name := XX ;
end ;


{$IFNDEF Simple}
Procedure Update_Journal ;

begin
    Set_Length( Journal_Buffer, Journal_Offset ) ; { Maintain string length }
    {$I-}
    Seek( Journal, Journal_Record ) ;
    Write( Journal, Journal_Buffer ) ; { Update journal }
    Reset( Journal ) ;
    {$I+}
end ;
{$ENDIF}


Procedure Show_Message( X : string; Force : boolean ) ;

begin
    if( ( ( Editor^.Options and eds_NoMessages ) = 0 ) or Force ) then
    begin
	Error_Flag := True ;
	Select_Window( Error_Window ) ;
	Writeln( Scr ) ; { Clear line }
	Write( Scr, X ) ; { Show message text }
	Unmap_Window( Status_Window ) ; { Unmap status window so error can show }
	Update_Window( Error_Window ) ;
	Select_Window( Editor^.Screen_Window )
    end ;
end ;


Procedure Show_Error( X : string; Force : boolean ) ;
{Show error text}

begin
    Message_Beep ; { Get their attention }
    Show_Message( X, Force ) ; { Show the message text }
{$IFNDEF Simple}
    Current_Key_Output := nil ; { Terminate any key play-back }
    Key_Output := -1 ;
{$ENDIF}
end ;


procedure Notify( X : integer ) ; far ;

var S : string ;

begin
     case X of
	edn_Memory :
		S := 'Not enough memory' ;
	edn_Top :
		S := 'Backup past beginning of buffer' ;
	edn_Bottom :
		S := 'Advance beyond end of buffer' ;
	edn_Length :
 
		S := 'Line length exceeds 255 characters' ;
	edn_NotFound :
		S := 'Text not found' ;
	edn_NoSelection :
		S := 'Nothing selected' ;
	edn_Selection :
		S := 'Selection in progress' ;
	else
	    exit ; { Ignore all other messages }
    end ;
    Show_Error( S, False ) ;
end ;


{$IFNDEF Simple}
procedure Delete_Key_Command( Level, Ord_C : byte ) ;
{ Release key command memory allocated for the specified key }

var Temp_Key : pKeystrokes ;

begin
    if( Key_Commands[ Level ] <> nil ) then { Any key commans defined }
    begin
	if ( Key_Commands[ Level ]^[ Ord_C ] <> nil ) then { This one is defined }
	begin
	    { Release all space for specified key definition }
	    if( Key_Commands[ Level ]^[ Ord_C ]^.Parameters <> nil ) then
	    begin
		dispose( Key_Commands[ Level ]^[ Ord_C ]^.Parameters ) ;
	    end ;
	    Temp_Key := Key_Commands[ Level ]^[ Ord_C ]^.Definition ;
	    while( Temp_Key <> nil ) do
	    begin
		Key_Commands[ Level ]^[ Ord_C ]^.Definition := Temp_Key^.Next ;
		dispose( Temp_Key ) ;
		Temp_Key := Key_Commands[ Level ]^[ Ord_C ]^.Definition ;
	    end ;
	end ;
    end ;
end ;
{$ENDIF}


procedure End_Edit ; { Terminate TEU section }

var Level, Key : byte ;

begin
    if( Editor = nil ) then
    begin
	exit ;
    end ;
    Editor^.Done ; { Terminate editor object }
    Editor := nil ;

{$IFNDEF Simple}
    { Deallocate key command resources }
    for Level := 0 to 9 do
    begin
	for Key := 0 to 255 do
	begin
	    Delete_Key_Command( Level, Key ) ;
	end ;
    end ;

    { Reset Rainbow keypad }
    if( Get_Model = 2 ) then
    begin
	Write( '>' ) ; { Numeric keypad if Rainbow }
    end ;
{$ENDIF}

    End_Smu ; { Nicely terminate SMU }
end ;


{$IFNDEF Simple}
procedure Store_Keystrokes( X : string ) ;
{ Record keystrokes for journaling and playback }

var A, B : Byte ;

begin
    { Handle macro }
    if( ( Key_Input <> nil ) and ( X <> chr( 11 ) ) and ( X <> chr( 18 ) ) ) then
    { If recording a learn sequence and not a ^K or ^R }
    begin
	if( Current_Key_Input^.Offset + length( X ) > 254 ) then
	begin
	    if( Maxavail < sizeof( tKey_Definition ) ) Then
	    { Ran out of memory }
	    begin
		Show_Error( '?Maximum memory exceeded', False ) ;
		End_Edit ;
		Halt ;
	    end ;
	    new( Current_Key_Input^.Next ) ;
	    Current_Key_Input := Current_Key_Input^.Next ;
	    Current_Key_Input^.Offset := 0 ; { New record }
	    Current_Key_Input^.Next := nil ;
	end ;
	Current_Key_Input^.Buffer := Current_Key_Input^.Buffer +
	    chr( length( X ) + 1 ) + chr( length( X ) ) + X ;
	    {Copy length for this string and the string itself}
	Current_Key_Input^.Offset := Current_Key_Input^.Offset +
	    length( X ) + 2 ;
    end ;

    { Handle journaling }
    if( Journal_Size > 0 ) then { If journaling is on }
    begin
	if( Journal_Offset + Length( X ) > 254 ) then
	{ Too big to fit in this string }
	begin
	    inc( Journal_Offset ) ;
	    Journal_Buffer[ Journal_Offset ] := #0 ; { end of this buffer }
	    Update_Journal ;
	    Journal_Offset := 0 ;
	    Inc( Journal_Record ) ; { New record }
	end ;
	A := Journal_Offset ;
	Inc( Journal_Offset ) ;
	Journal_Buffer[ Journal_Offset ] := chr( length( X ) ) ;
	{ Length for this string }
	for B := 1 to Length( X ) do
	begin
	    Inc( Journal_Offset ) ;
	    Journal_Buffer[ Journal_Offset ] := X[ B ] ;
	    { Copy string to buffer }
	end ;
	if(
            ( Journal_Offset and ( not Journal_Size ) ) >
	    ( A and ( not Journal_Size ) )
          ) then
        begin
            Update_Journal ;
        end ;
	{ More than n characters since last write }
    end ;
end ;
{$ENDIF}


function Get_Key( var Flag : boolean ) : string ;
{ Get key, if any, from playback or journal.  If a null is returned the Flag
  must be checked.  If Flag is True, there is no playback or journal input
  available. }

var A, B : byte ;
    Temp_Key : pKeystrokes ; { For aborting keystroke recording }
    X : ShortString ;

begin
    { Assume nothing available... }
    Flag := True ;
    X := '' ;

{$IFNDEF Simple}
    { Get the key }
    if( Key_Output >= 0 ) then { Get input from recorded keystrokes }
    begin
	B := ord( Current_Key_Output^.Buffer[ Current_Key_Output^.Offset ] ) ;
	{ Get length of next keystroke }
	inc( Current_Key_Output^.Offset ) ;
	for A := 0 to B + 1 do
	begin
	    X[ A ] := Current_Key_Output^.Buffer[ A + Current_Key_Output^.Offset ] ;
	    { Get keystroke }
	    Flag := False ;
	end ;
	Current_Key_Output^.Offset := Current_Key_Output^.Offset + B ;
	if( length( Current_Key_Output^.Buffer ) <= Current_Key_Output^.Offset ) then
	{ Done with this buffer }
	begin
	    Current_Key_Output := Current_Key_Output^.Next ;
	    if( Current_Key_Output <> nil ) then
	    begin
		Current_Key_Output^.Offset := 1 ;
	    end else
	    begin
		Key_Output := -1 ;
	    end ;
	end ;
    end else
    begin
	if( Recover ) then { /RECOVER mode }
	begin
	    B := Byte( Journal_Buffer[ 1 ] ) ; { Get length of next keystroke }
	    for A := 0 to B + 1 do
	    begin
		X[ A ] := Journal_Buffer[ A + 1 ] ; { Get keystroke }
	    end ;
	    Flag := False ;
	    Journal_Buffer := Copy( Journal_Buffer, B + 2, 255 ) ;
	    if( length( Journal_Buffer ) = 0 ) then { Done with this buffer }
	    begin
		Inc( Journal_Record ) ;
		{$I-}
		Read( Journal, Journal_Buffer ) ;
		{$I+}
		if( Ioresult <> 0 ) then { Journal playback is over }
		begin
		    Recover := False ; { Have read it all }
		    Recover_Terminating := True ;
		    if( Key_Input <> nil ) then { In keystroke recording }
		    begin
			{ Release all space for existing key definition }
			Temp_Key := Key_Input ;
			while( Temp_Key <> nil ) do
			begin
			    Key_Input := Temp_Key^.Next ;
			    dispose( Temp_Key ) ;
			    Temp_Key := Key_Input ;
			end ;
		    end ; { if( Key_Input <> nil ) }
		end ;
	    end ;
	end ;
    end ;
{$ENDIF}
    Get_Key := X ;
end ;


function Default_Input_InKey : string ;

var S : string ;

begin
    repeat
        S := Default_Input.Inkey ;
    until ( ( S <> 'CONTROL' ) and ( S <> 'SHIFT' ) and ( S <> 'ALT' ) and ( S <> 'CAPS' ) and ( S <> 'SCROLL' ) and ( S <> 'NUMLOCK' ) and ( S <> 'APPS' ) and ( S <> 'LWIN' ) and ( S <> 'RWIN' ) ) ;
    Default_Input_InKey := S ;
end ;


function In_Key : string ;
{ Get next keystroke.  Keystrokes come from one of the following sources,
  in highest to lowest priority:
	1. Learn-key playbacks
	2. Journal (if /RECOVERY processing)
	3. Keyboard
}

var X : string ;
    Y : Boolean ;

begin
    X := Get_Key( Y ) ;
    if( ( length( X ) = 0 ) and Y ) then { Need to get from keyboard }
    begin
	X := Default_Input_Inkey ; { Get keystroke }
{$IFNDEF Simple}
	Store_Keystrokes( X ) ;
{$ENDIF}
    end ;
    In_Key := X ; { Return keystroke }
end ; { In_Key }


procedure Do_Read ; { Get next input line }

var Y : Boolean ;

begin
    KB_Buffer := Get_Key( Y ) ; { Get recovery/macro input }
    if( ( length( KB_Buffer ) = 0 ) and Y ) then { Need input from keyboard }
    begin
	Window_Read ; { Do the read }
{$IFNDEF Simple}
	Store_Keystrokes( KB_Buffer ) ;
{$ENDIF}
    end ;
end ; { Do_Read }


{$F+}
procedure Error ;
{ Standard error handler procedure }

begin
    End_Edit ; { Terminate screen stuff }
    Exitproc := Exitsave ; { Restore old vector }
    if( Erroraddr = nil ) then
    begin
        Exit ; { Normal exit }
    end ;
    Erroraddr := nil ; { We are reporting the error }
    Writeln( Ert( Exitcode ) )
end ;
{$F-}


procedure Do_Write( Command : string ; File_Root : pLine_Buffer ) ;
{ Write specified buffer to a file }

var Input_File : Text ;
    T_Pointer : Line_Pointer ;

begin
    Assign( Input_File, Command ) ;
    {$I-}
    Rewrite( Input_File ) ; { Open input file }
    {$I+}
    Dummy := Ioresult ;
    if( Dummy <> 0 ) then
    begin
	Show_Error( Ert( Dummy ) + ' - creating ' + Command, True ) ;
	Exit ;
    end ;
    T_Pointer := File_Root^.Start ;
    while( T_Pointer <> Nil ) do { Until end of buffer }
    begin
	Writeln( Input_File, T_Pointer^.Text ) ; { Write next line }
	T_Pointer := T_Pointer^.Next_Line ; { Follow pointer to next line }
    end ;
    Close( Input_File ) ;
end ;


function Include_File( Command : string ; File_Root : pLine_Buffer ) : longint ;
{ Read a file into a buffer.  Returns number of lines read in. }

var Buffer : array[ 0..511 ] of char ;
    Input_File : file ;
    Position : integer ;
    Size, Start : integer ;
    Too_Long : boolean  ;

    function Add_string : boolean ;

    var S : string ;

    begin
	Add_string := False ;
	if( Position > Start + 255 ) then { Position includes delimiter }
	begin
	    Too_Long := True ;
	    Setlength( S, 255 ) ;
	end else
	begin
	    Setlength( S, Position - Start ) ; { Don't include delimiter }
	end ;
	move( Buffer[ Start ], S[ 1 ], length( S ) ) ;
	if( Maxavail > length( S ) + Line_Overhead ) then
	begin
	    File_Root^.Append( S ) ;
	end else
	begin
	    File_Root^.Zero ; { Reclaim memory }
	    Show_Error( '?Not enough memory', False ) ;
	    Include_File := -1 ; { Signal error }
	    Add_string := True ;
	    exit ;
	end ;
    end ; { Include_File.Add_string }

begin { Include_File }
    Too_Long := False ;
    Include_File := 0 ; { Assume no lines read in }
    Assign( Input_File, Command ) ;
    FileMode := 0 ;
    {$I-}
    Reset( Input_File, 1 ) ;
    {$I+}
    FileMode := 2 ;
    Dummy := Ioresult ;
    If( Dummy <> 0 ) then
    begin
	Show_Error( Ert( Dummy ) + ' - opening ' + Command, True ) ;
	Exit ;
    end ;
    Size := sizeof( Buffer ) ;
    while( Size = sizeof( Buffer ) ) do
    begin
	{$I-}
	blockread( Input_File, Buffer, sizeof( Buffer ), Size ) ;
	{$I+}
	if( IOResult <> 0 ) then
	begin
	    Size := 0 ;
	    break ;
	end ;
	Position := 0 ;
	while( Position < Size ) do
	begin
	    Start := Position ;

	    { Find next delimiter }
	    while(
		   ( Position < Size )
		   and
		   ( pos( Buffer[ Position ], CRLF ) = 0 )
		 ) do
	    begin
		inc( Position ) ;
	    end ;

	    { Add the line to the buffer... }
	    while( Position - Start > 255 ) do { Line too long }
	    begin
		if( Add_string ) then
		begin
		    exit ;
		end ;
		Start := Start + 255 ;
	    end ;
	    if( Position = sizeof( Buffer ) ) then { Couldn't find end of line in buffer }
	    begin
		{ Shift buffer down by 256 bytes, read in 256 more bytes,
		  adjust positions and size and continue. }
		move( Buffer[ 256 ], Buffer[ 0 ], 256 ) ;
		Start := Start - 256 ;
		Position := Start ;
		{$I-}
		blockread( Input_File, Buffer[ 256 ], 256, Size ) ;
		{$I+}
		if( IOResult <> 0 ) then
		begin
		    exit ;
		end ;
		Size := Size + 256 ;
		continue ;
	    end ;
	    Add_string ;

	    { Since CR and LF are paired, skip the one if we stopped on the
	      other.  Either alone is sufficient for ending a line too... }
	    if( Position = sizeof( Buffer ) - 1 ) then
	    { Can't check next byte since we don't have it yet }
	    begin
		Position := 0 ;
		Buffer[ 0 ] := Buffer[ sizeof( Buffer ) - 1 ] ;
		{$I-}
		blockread( Input_File, Buffer[ 1 ], 511, Size ) ;
		{$I+}
		if( IOResult <> 0 ) then
		begin
		    exit ;
		end ;
		Size := Size + 1 ;
	    end ;
	    if( Buffer[ Position ] = CR ) then
	    begin
		if( Buffer[ Position + 1 ] = LF ) then
		begin
		    inc( Position ) ;
		end ;
	    end else
	    if( Buffer[ Position ] = LF ) then
	    begin
		if( Buffer[ Position + 1 ] = CR ) then
		begin
		    inc( Position ) ;
		end ;
	    end ;
	    inc( Position ) ; { Go past delimiter }
	end ; { while( Position < Size ) }
    end ;
    Close( Input_File ) ;
    Include_File := File_Root^.Last_Line ;
    if( Too_Long ) then
    begin
	Show_Error( 'Some line(s) too long - split into multiple lines reading ' + Command, True ) ;
    end ;
end ; { Include_File }


procedure Do_Help ; { Display help on screen }

Var Dummy : Integer ;
    Input_Line : string ;
    Line_Count : Integer ;
    Help_File : Text ;

    procedure Restore_Screen ;

    begin
	Select_Window( Editor^.Screen_Window ) ;
	Close( Help_File ) ;
	Clear_Window( Editor^.Screen_Window ) ; { Erase screen and home cursor }
	Editor^.Redraw( 1 ) ;
    end ;

begin
    Assign( Help_File, Help_File_Name ) ;
    FileMode := 0 ;
    {$I-}
    Reset( Help_File ) ;
    {$I+}
    FileMode := 2 ;
    if( Ioresult <> 0 ) then
    begin
	Show_Error( 'Help not available', False ) ;
	Exit ;
    end ;
    Clear_Window( Editor^.Screen_Window ) ;
    Line_Count := 0 ;
    while( not Eof( Help_File ) ) do
    begin
	Readln( Help_File, Input_Line ) ; { Get next line }
	if(
            ( ( Get_Model = 2 ) and ( Copy( Input_Line, 1, 1 ) <> '!' ) ) { DEC Rainbow }
            or
	    ( ( Get_Model <> 2 ) and ( Copy( Input_Line, 1, 1 ) <> '~' ) )
          ) then
        begin
            if Copy( Input_Line, 1, 1 ) = '!' then
            begin
                Input_Line := Copy( Input_Line, 2, 254 ) ;
            end ;
            if Copy( Input_Line, 1, 1 ) = '~' then
            begin
                Input_Line := Copy( Input_Line, 2, 254 ) ;
            end ;
            Dummy := Pos( '', Input_Line ) ; { Locate special symbol }
            while( Dummy > 0 ) do
            begin
                Write( Scr, Copy( Input_Line, 1, Dummy - 1 ) ) ; { Show first part }
                Input_Line := Copy( Input_Line, Dummy + 1, 255 ) ; { Extract rest }
                Set_Window( Editor^.Screen_Window, 0, 0, 0, -1 ) ; { Now reverse video }
                Dummy := Pos( '', Input_Line ) ;
                if( Dummy > 0 ) then { Found one }
                begin
                    Write( Scr, Copy( Input_Line, 1, Dummy - 1 ) ) ; { Show first part }
                    Input_Line := Copy( Input_Line, Dummy + 1, 255 ) ;
                    { Extract rest }
                    Set_Window( Editor^.Screen_Window, 0, 0, 0, -32 ) ;
                    { Now normal video }
                end ;
                Dummy := Pos( '', Input_Line ) ; { Locate another }
            end ;
            Writeln( Scr, Input_Line ) ;
            Set_Window( Editor^.Screen_Window, 0, 0, 0, -32 ) ; { Normal text }
            Line_Count := Line_Count + 1 ;
            if( Line_Count = Screen_Height - 3 ) then
            begin
                Line_Count := 1 ;
                Update_Window( Editor^.Screen_Window ) ;
                Show_Message( 'More...', True ) ;
                Select_Window( Error_Window ) ;
{$IFNDEF Simple}
                if( Recover_Terminating ) then
                { Abort if /RECOVER just finished }
                begin
                    Restore_Screen ;
                    exit ;
                end ;
{$ENDIF}
                Do_Read ;
                Select_Window( Editor^.Screen_Window ) ;
                if( Length( Kb_Buffer ) > 0 ) then
                begin
                    if(
                        ( Kb_Buffer[ 1 ] = '' )
                        or
                        ( Kb_Buffer[ 1 ] = '' )
                        or
                        ( Kb_Buffer[ 1 ] = Chr( 26 ) )
                      ) then
                    begin
                        Restore_Screen ;
                        Exit ;
                    end ;
                end ;
            end ;
        end ;
    end ;
    Update_Window( Editor^.Screen_Window ) ;
    Show_Message( 'Press ENTER to continue...', True ) ;
    Select_Window( Error_Window ) ;
{$IFNDEF Simple}
    if( not Recover_Terminating ) then { Abort if /RECOVER just finished }
{$ENDIF}
    begin
	Do_Read ;
    end ;
    Restore_Screen ;
end ;


procedure Search ; { Search for text }

begin
    Editor^.Format( Search_Text ) ;
    Show_Message( 'Searching for: ' + Editor^.Logical, False ) ;
    if( Editor^.Do_Search( Search_Text ) ) then { Found something }
    begin
	Show_Message( '', False ) ;
    end ;
end ;


procedure TEU_Load ; { Load key macro from file }

var Character : string ;
    Ord_C : integer ;

begin
    Show_Message( 'Enter keystroke who definition you wish to save', False ) ;
    Character := Default_Input_InKey ;
    if( ( length( Character ) > 1 ) or ( Character = CR ) ) then
    begin
	Show_Message( 'Store aborted', False ) ;
	exit ;
    end ;
    Ord_C := ord( Character[ 1 ] ) ;
{~~~}

	{ Cancel any existing key definition for the specified key }
	Delete_Key_Command( 0, Ord_C ) ;
end ;


procedure TEU_Store ; { Save key macro to a file }

var Character : string ;
    Ord_C : integer ;

begin
    Show_Message( 'Enter keystroke who definition you wish to save', False ) ;
    Character := Default_Input_InKey ;
    if( ( length( Character ) > 1 ) or ( Character = CR ) ) then
    begin
	Show_Message( 'Store aborted', False ) ;
	exit ;
    end ;
    Ord_C := ord( Character[ 1 ] ) ;

	Delete_Key_Command( 0, Ord_C ) ;
    {~~~}
end ;


procedure TEU_Quit ; { Exit editor with no changes to file }

begin
    Editor^.Do_Update ; { Update current line }
    if( Editor^.Any_Changes ) then
    begin
	Clear_Cursor( 0, 0 ) ; { Disable cursor (enabled by "Command:" input) }
{$IFNDEF Simple}
	if( Recover_Terminating ) then { Abort if /RECOVER just finished }
	begin
	    exit ;
	end ;
{$ENDIF}
	Show_Message( 'Modifications will not be saved - continue quitting <NO> ?', True ) ;
	Character := In_Key ; { Get next character }
	if( ( Character <> 'Y' ) and ( Character <> 'y' ) ) then { Not "YES" }
	begin
	    Show_Message( '', True ) ;
	    Exit ;
	end ;
    end ;
    if( New_File ) then
    begin
        Erase( Input_File ) ; { Delete new files during a quit }
    end ;
{$IFNDEF Simple}
    Close( Journal ) ;
    Erase( Journal ) ; { Close and delete journal file }
{$ENDIF}
    End_Edit ;
    Halt ;
end ;



procedure TEU_Exit ;

begin
    Editor^.Do_Update ; { Update current line }
    Select_Window( Error_Window ) ;
    Unmap_Window( Status_Window ) ;
    Write( Scr, Input_Name, '  ', Editor^.File_Root^.Last_Line, ' line' ) ;
    if( Editor^.File_Root^.Last_Line <> 1 ) then
    begin
	Write( Scr, 's' ) ;
    end ;
    Update_Window( Error_Window ) ;
    if( Editor^.Any_Changes ) then { If changes made }
    begin
	Command := Input_Name ; { Save name for later comparison }
	if( not New_File ) then { Editing of existing file }
	begin
	    Dummy := Extension_Pos( Input_Name ) ;
	    if( Dummy = 0 ) then
	    begin
		Dummy := length( Input_Name ) + 1 ;
	    end ;
	    Input_Name := Copy( Input_Name, 1, Dummy - 1 ) + '.BAK' ;
	    { Strip extension }
	    Assign( Input_File, Input_Name ) ;
	    {$I-}
	    Erase( Input_File ) ; { Delete old backup }
	    {$I+}
	    Dummy := Ioresult ; { Clear any errors }
	    Assign( Input_File, Command ) ;
	    if( Command <> Input_Name ) then
            begin
                Rename( Input_File, Input_Name ) ;
	        { Rename previous file to *.BAK, unless old file WAS *.BAK }
            end ;
	end ;
	Do_Write( Command, Editor^.File_Root ) ; { Write to file }
    end ;
{$IFNDEF Simple}
    Close( Journal ) ;
    Erase( Journal ) ; { Close and delete journal file }
{$ENDIF}
    End_Edit ;
    Halt ;
end ;


procedure TEU_Include( Command : string ) ;

var T1_Pointer : pLine_Buffer ;
    Temp : Longint ;

begin
    Editor^.Do_Update ; { Update current line }
    T1_Pointer := new( pLine_Buffer, Init ) ;
    Temp := Include_File( Command, T1_Pointer ) ;
    if( Temp < 0 ) then
    begin
	dispose( T1_Pointer, Done ) ;
	Exit ; { Insufficient memory }
    end ;
    if( Temp > 0 ) then { Something was read in }
    begin
	if( Editor^.File_Root^.Last_Line <> 0 ) then
	{ Pasting into existing text }
	begin

	    { Need to put blank line at end to imply CRLF. }
	    if( Maxavail > Line_Overhead ) then
	    begin
		T1_Pointer^.Append( '' ) ;
	    end else
	    begin
		dispose( T1_Pointer, Done ) ;
		Show_Error( '?Not enough memory', False ) ;
		Exit ;
	    end ;

	    Editor^.Paste( T1_Pointer ) ; { Append to existing buffer }
	    dispose( T1_Pointer, Done ) ;
	end else
	begin
	    dispose( Editor^.File_Root, Done ) ; { Becomes new buffer }
	    Editor^.Set_Buffer( T1_Pointer ) ;
	    Editor^.Redraw( 1 ) ;
	end ;
    end ;
end ;


procedure Set_Default_Screen_Height ;

{$IFDEF MSDOS_OR_DPMI}
var C : Integer ;
    Reg : Tregisters ;
    Info : array[ 0..255 ] of byte ;
{$ENDIF}

begin
    Screen_Height := 24 ;
{$IFDEF MSDOS}
    C := Mem[ $F000 : $FFFE ] ; { Get machine type }
    if( C >= $F8 ) then { A PC of some type }
{$ENDIF}
{$IFDEF MSDOS_OR_DPMI}
    begin
	Reg.AX := $1A00 ;
	Reg.BX := 0 ;
	Intr( $10, Reg ) ;
	Reg.AX := $1B00 ;
	Reg.BX := 0 ;
	Reg.ES := seg( Info ) ;
	Reg.DI := ofs( Info ) ;
	Intr( $10, Reg ) ;
	if( Reg.AL = $1B ) then { VGA or higher }
	begin
	    Screen_Height := Info[ $22 ] - 1 ;
	end ;
    end ;
{$ENDIF}
end ;


procedure TEU_Set( Command : string ) ; { Process SET commands }

var Temp : longint ;

begin
    Editor^.Do_Update ; { Update current line }

    Dummy := Pos( ' ', Command + ' ' ) ; { Find end of (first) parameter }
    if( Copy( Command, 1, 1 ) = 'A' ) then { SET AUTOINDENT }
    begin
	Command := Copy( Command, Dummy + 1, Length( Command ) ) ;
	{ Strip AUTOINDENT }
	if( Length( Command ) = 0 ) then
	begin
	    Editor^.Options := Editor^.Options or eds_AutoIndent ; { Default to SET AUTOINDENT ON }
	end else
	begin
	    if( Command = 'ON' ) then
	    begin
		Editor^.Options := Editor^.Options or eds_AutoIndent ; { Turn it on }
	    end else
	    begin
		if( Command = 'OFF' ) then
		begin
		    Editor^.Options := Editor^.Options and (not eds_AutoIndent ) ; { Turn it off }
		end else
		begin
		    Show_Error( 'Illegal command', True ) ;
		end ;
	    end ;
	end ;
	Exit ;
    end ;

    if( Copy( Command, 1, 1 ) = 'C' ) then { SET CURSOR }
    begin
	Command := Copy( Command, Dummy + 1, Length( Command ) ) ;
	{ Strip CURSOR }
	if( Length( Command ) = 0 ) then
	begin
	    Editor^.Options := Editor^.Options or eds_CursorBound ; { Default to SET CURSOR BOUND }
	end else
	begin
	    if( Command = 'BOUND' ) then
	    begin
		Editor^.Options := Editor^.Options or eds_CursorBound ; { Turn it on }
	    end else
	    begin
		if( Command = 'UNBOUND' ) then
		begin
		    Editor^.Options := Editor^.Options and ( not eds_CursorBound ) ;
		    { Turn it off }
		end else
		begin
		    Show_Error( 'Illegal command', True ) ;
		end ;
	    end ;
	end ;
	Exit ;
    end ;

    if( Copy( Command, 1, 3 ) = 'EOB' ) then { SET EOB }
    begin
	Command := Copy( Command, Dummy + 1, Length( Command ) ) ;
	{ Strip EOB }
	if( ( Command[ 1 ] = chr( 39 ) ) or ( Command[ 1 ] = '"' ) ) then
	begin
	    if( Command[ length( Command ) ] = Command[ 1 ] ) then
	    begin
		Command := copy( Command, 1, length( Command ) - 1 ) ;
	    end ;
	    Command := copy( Command, 2, 254 ) ;
	end ;
	Editor^.End_Of_Buffer_string := Command ;
	Dummy := Editor^.File_Root^.Last_Line + 1 ;
	if( Dummy > Screen_Height - 1 ) then
	begin
	    Dummy := Screen_Height - 1 ;
	end ;
	Editor^.Redraw( Dummy ) ;
	Exit ;
    end ;

    if( Copy( Command, 1, 3 ) = 'EOL' ) then { SET EOL }
    begin
	Command := Copy( Command, Dummy + 1, Length( Command ) ) ;
	{ Strip EOB }
	if( length( Command ) > 0 ) then
	begin
	    if Command = 'OFF' then
	    begin
		Command := '0' ;
	    end ;
	    Val( Command, Temp, Dummy ) ;
	    if(
                ( Dummy <> 0 )
                or
                ( Temp = 8 )
                or
                ( Temp = 10 )
                or
		( Temp = 13 )
                or
                ( Temp < 0 )
                or
                ( Temp > 253 )
              ) then { Error }
	    begin
		Show_Error( 'Invalid parameter', True ) ;
		exit ;
	    end ;
	end else
	begin
	    Temp := 4 ; { Default to diamond }
	end ;
	Editor^.End_Of_Line_Character := chr( Temp ) ;
	Editor^.Redraw( 1 ) ;
	Exit ;
    end ;

    if( Copy( Command, 1, 1 ) = 'H' ) then { SET HEIGHT }
    begin
	Command := Copy( Command, Dummy + 1, Length( Command ) ) ;
	{ Strip HEIGHT }
	if( Length( Command ) = 0 ) then
	begin
	    Set_Default_Screen_Height ;
	end else
	begin
	    Val( Command, Temp, Dummy ) ;
	    if( ( Dummy <> 0 ) or ( Temp < 2 ) ) then { Error }
	    begin
		Show_Error( 'Invalid parameter', True ) ;
	    end Else
	    begin
		Screen_Height := Temp ;
	    end ;
	end ;
	Resize( Editor^.Screen_Window, Screen_Height - 1, 80 ) ;
	Unmap_Window( Editor^.Screen_Window ) ;
	Unmap_Window( Error_Window ) ;
	Unmap_Window( Status_Window ) ;
	Map_Window( Editor^.Screen_Window, 1, Screen_Height - 1, 1,
	    Window_Width, 1, 1, 128 ) ;
	Map_Window( Error_Window, Screen_Height, 1, 1, Window_Width, 1, 1, 128 ) ;
	Editor^.Calculate_Rows( Screen_Height - 1 ) ;
	Editor^.Last_Screen_Line := 0 ;
	Editor^.Redraw( 1 ) ;
	exit ;
    end ;

{$IFNDEF Simple}
    if( Copy( Command, 1, 1 ) = 'J' ) then { SET JOURNAL }
    begin
	Command := Copy( Command, Dummy + 1, Length( Command ) ) ; { Strip JOURNAL }
	if( Length( Command ) > 0 ) then
	begin
	    if( Command = 'OFF' ) then
            begin
                Command := '0' ;
            end ;
	    Val( Command, Temp, Dummy ) ;
	    if( ( Dummy <> 0 ) or ( Temp < 0 ) or ( Temp > 64 ) ) then { Error }
	    begin
		Show_Error( 'Invalid parameter', True ) ;
	    end Else
	    begin
		if( Temp = 64 ) then
                begin
                    Temp := 127 ;
                end ;
		if( ( Temp > 32 ) and ( Temp <= 64 ) ) then
                begin
                    Temp := 63 ;
                end ;
		if( ( Temp > 16 ) and ( Temp <= 32 ) ) then
                begin
                    Temp := 31 ;
                end ;
		if( ( Temp > 8 ) and ( Temp <= 16 ) ) then
                begin
                    Temp := 15 ;
                end ;
		if( ( Temp > 4 ) and ( Temp <= 7 ) ) then
                begin
                    Temp := 7 ;
                end ;
		if( ( Temp > 2 ) and ( Temp <= 4 ) ) then
                begin
                    Temp := 3 ;
                end ;
		if( ( Temp > 0 ) and ( Temp <= 2 ) ) then
                begin
                    Temp := 1 ;
                end ;
		Journal_Size := Temp ; { New journaling size }
	    end ;
	end ;
	Exit ;
    end ;
{$ENDIF}

    if( Copy( Command, 1, 1 ) = 'M' ) then { SET MESSAGE }
    begin
	Command := Copy( Command, Dummy + 1, Length( Command ) ) ;
	{ Strip MESSAGES }
	if( Length( Command ) = 0 ) then
	begin
	    Editor^.Options := Editor^.Options and ( not eds_NoMessages ) ;
	    { Default to SET MESSAGES ON }
	end else
	begin
	    if( Command = 'ON' ) then
	    begin
		Editor^.Options := Editor^.Options and ( not eds_NoMessages ) ; { Turn it on }
	    end else
	    begin
		if( Command = 'OFF' ) then
		begin
		    Editor^.Options := Editor^.Options or eds_NoMessages ; { Turn it off }
		end else
		begin
		    Show_Error( 'Illegal command', True ) ;
		end ;
	    end ;
	end ;
	Exit ;
    end ;

    if( Copy( Command, 1, 2 ) = 'ST' ) then { SET STATUS }
    begin
	Command := Copy( Command, Dummy + 1, Length( Command ) ) ;
	{ Strip STATUS }
	if( Length( Command ) = 0 ) then
	begin
	    Status := True ; { Default to SET STATUS ON }
	end else
	begin
	    if( Command = 'ON' ) then
	    begin
		Status := True ;
	    end else
	    begin
		if( Command = 'OFF' ) then
		begin
		    Status := False ;
		end else
		begin
		    Show_Error( 'Illegal command', True ) ;
		    exit ;
		end ;
	    end ;
	end ;
	exit ;
    end ;

    if( Copy( Command, 1, 2 ) = 'SU' ) then { SET SUBWINDOW }
    begin
	Command := Copy( Command, Dummy + 1, Length( Command ) ) ;
	{ Strip SUBWINDOW }
	if( Length( Command ) = 0 ) then
	begin
	    Editor^.Options := Editor^.Options or eds_SubWindow ;
	    { Default to SET SUBWINDOW ON }
	end else
	begin
	    if( Command = 'ON' ) then
	    begin
		Editor^.Options := Editor^.Options or eds_SubWindow ; { Turn it on }
	    end else
	    begin
		if( Command = 'OFF' ) then
		begin
		    Editor^.Options := Editor^.Options and ( not eds_SubWindow ) ;
		    { Turn it off }
		end else
		begin
		    Show_Error( 'Illegal command', True ) ;
		    exit ;
		end ;
	    end ;
	end ;
	Editor^.Resize ;
	exit ;
    end ;

    if( copy( Command, 1, 2 ) = 'TA' ) then { SET TABSTOPS }
    begin
	Command := Copy( Command, Dummy + 1, Length( Command ) ) ;
	{ Strip TABSTOPS }
	if( length( Command ) > 0 ) then
	begin
	    Val( Command, Temp, Dummy ) ;
	    if( ( Dummy <> 0 ) or ( Temp < 0 ) or ( Temp > 128 ) ) then { Error }
	    begin
		Show_Error( 'Invalid parameter', True ) ;
	    end else
	    begin
		if( Temp = 1 ) then
		begin
		    Editor^.Options := Editor^.Options or eds_NoTabs ;
		end else
		begin
		    Editor^.Tab_Size := Temp ;
		    Editor^.Options := Editor^.Options and ( not eds_NoTabs ) ;
		end ;
	    end ;
	end else
	begin
	    Editor^.Tab_Size := 8 ; { Default }
	    Editor^.Options := Editor^.Options and ( not eds_NoTabs ) ;
	end ;
	Editor^.Last_Screen_Line := 0 ;
	Editor^.Redraw( 1 ) ;
	exit ;
    end ;

    if( Copy( Command, 1, 2 ) = 'TO' ) then { SET TONE }
    begin
	Command := Copy( Command, Dummy + 1, Length( Command ) ) ;
	{ Strip TONE }
	if Length( Command ) = 0 then
	begin
	    Editor^.Options := Editor^.Options or eds_Beep ;
	    { Default to SET TONE ON }
	end else
	begin
	    if Command = 'ON' then
	    begin
		Editor^.Options := Editor^.Options or eds_Beep ; { Turn it on }
	    end else
	    begin
		if Command = 'OFF' then
		begin
		    Editor^.Options := Editor^.Options and ( not eds_Beep ) ; { Turn it off }
		end else
		begin
		    Show_Error( 'Illegal command', True ) ;
		end ;
	    end ;
	end ;
	Exit ;
    end ;

    if( copy( Command, 1, 2 ) = 'TR' ) then { SET TRANSLATION }
    begin
	Command := Copy( Command, Dummy + 1, Length( Command ) ) ;
	{ Strip TRANSLATION }
	if Length( Command ) = 0 then
	begin
	    Show_Error( 'Missing parameter', True ) ;
	    exit ;
	end ;
	Dummy := Pos( ' ', Command + ' ' ) ;
	val( copy( Command, 1, Dummy - 1 ), Temp, Dummy ) ;
	if( ( Dummy <> 0 ) or ( Temp < 0 ) or ( Temp > 255 ) ) then
	begin
	    Show_Error( 'Invalid parameter', True ) ;
	    exit ;
	end ;
	Dummy := Pos( ' ', Command + ' ' ) ;
	Command := Copy( Command, Dummy + 1, Length( Command ) ) ;
	FEdit( Command, Command, 8 or 128 ) ;
	if( length( Command ) = 0 ) then
	begin
	    if( ( Temp = 0 ) or ( Temp = 8 ) or ( Temp = 254 ) ) then
	    begin
		Editor^.Translation[ Temp ] := chr( 178 ) ;
	    end else
	    begin
		Editor^.Translation[ Temp ] := chr( Temp ) ;
	    end ;
	end else
	begin
	    if( ( Command[ 1 ] = '"' ) or ( Command[ 1 ] = #39 ) ) then
	    begin
		if( Command[ length( Command ) ] = Command[ 1 ] ) then
		begin
		    Command := copy( Command, 1, length( Command ) - 1 ) ;
		end ;
		Command := copy( Command, 2, 254 ) ;
	    end ;
	    Editor^.Translation[ Temp ] := Command ;
	end ;
	Editor^.Last_Screen_Line := 0 ;
	Editor^.Redraw( 1 ) ;
	exit ;
    end ;

    if Length( Command ) = 0 then
    begin
	Show_Error( 'Missing operand', True ) ;
    end else
    begin

	Show_Error( 'Illegal command', True ) ;
    end ;
end ;


procedure TEU_Spawn ;

{$IFNDEF DELPHI}
var Command_Com : string ; { Name of COMMAND.COM file }
    Directory : string ; { Saved current directory }
    Spawn_Window : PWindow ;
    Reg : TRegisters ;
{$ENDIF}

begin
{$IFNDEF DELPHI}
    Spawn_Window := Create_Window( Screen_Height, Window_Width, 4 ) ;
    Map_Window( Spawn_Window, 1, Screen_Height, 1, Window_Width, 1, 1, 253 ) ;
    Update_Window( Spawn_Window ) ; { Clear screen }
    if( Get_Model = 2 ) then { DEC Rainbow }
    begin
	Write( '>[', Screen_Height, ';1H' ) ;
	{ Go to last line, column 1, numeric keypad }
	Reg.Di := 10 ;
	Compatib.Intr( $18, Reg ) ; { Enable cursor }
    end ;
    Getdir( 0, Directory ) ; { Save current disk/directory }
    Command_Com := Getenv( 'COMSPEC' ) ;
    if( Length( Command_Com ) = 0 ) then { Not defined }
    begin
	Command_Com := File_Name( 'COMMAND.COM' ) ;
    end ;
    OS^.Spawn( Command_Com, '' ) ; { Spawn }
    if( Doserror <> 0 ) then
    begin
        Writeln( Ert( Doserror ) ) ; { Show error }
    end ;
    {$I-}
    Chdir( Directory ) ;
    {$I+}
    if( Get_Model = 2 ) then { DEC Rainbow }
    begin
	Write( '[?3l=' ) ;
	{ Reset screen to set up screen RAM properly; application keypad }
	Reg.Di := 8 ;
	Intr( $18, Reg ) ; { Disable cursor }
    end ;
    Unmap_Window( Spawn_Window ) ;
    Delete_Window( Spawn_Window ) ;
    Update_Window( Editor^.Screen_Window ) ;
{$ENDIF}
end ;


procedure TEU_Write ;

begin
    Editor^.Do_Update ; { Update current line }
    Dummy := Pos( ' ', Command + ' ' ) ;
    Command := Copy( Command, Dummy + 1, Length( Command ) ) ;
    Do_Write( Command, Editor^.File_Root ) ;
end ;


procedure Execute_Command( Command : string ) ; { Execute a TEU command }

var Dummy : integer ;
    Temp : longint ;

begin
    if( Length( Command ) = 0 ) then
    begin
        Exit ; { Igore blank lines }
    end ;

    if( Command[ 1 ] = '' ) then
    begin
	End_Edit ;
	Halt ; { ^Y will abort }
    end ;

    if( Command[ 1 ] = '' ) then
    begin
        Exit ; { ^C is ignored here }
    end ;

    if( copy( Command, 1, 1 ) = 'C' ) then { CLEAR command }
    begin
	if Editor^.Any_Changes then
	begin
	    Clear_Cursor( 0, 0 ) ; { Disable cursor (enabled by "Command:" input) }
{$IFNDEF Simple}
	    if( Recover_Terminating ) then { Abort if /RECOVER just finished }
	    begin
		exit ;
	    end ;
{$ENDIF}
	    Show_Message( 'Modifications will not be saved - continue quitting <NO> ?', True ) ;
	    Character := In_Key ; { Get next character }
	    Show_Message( '', True ) ;
	    if( ( Character <> 'Y' ) and ( Character <> 'y' ) ) then { Not "YES" }
	    begin
		Exit ;
	    end ;
	end ;
	Editor^.Clear( True ) ;
	Editor^.Any_Changes := True ;
	exit ;
    end ;

    if( Copy( Command, 1, 1 ) = 'E' ) then { EXIT command }
    begin
	TEU_Exit ;
	exit ;
    end ;

    if( Command[ 1 ] = 'G' ) then { GOTO command }
    begin
	Dummy := Pos( ' ', Command + ' ' ) ; { Find filename }
	Command := Copy( Command, Dummy + 1, Length( Command ) ) ;
	{ Get filename }
	Val( Command, Temp, Dummy ) ;
	if( Dummy <> 0 ) then
	begin
	    Show_Error( 'Invalid line number', False ) ;
	    exit ;
	end ;
	if( Temp < 1 ) then
	begin
	    Temp := 1 ;
	end ;
	if( Temp > Editor^.File_Root^.Last_Line ) then
	begin
	    Temp := Editor^.File_Root^.Last_Line ;
	end ;
	if( Temp > 0 ) then { Something in buffer }
	begin
	    Editor^.Position_Cursor( Temp, 1 ) ;
	end ;
	exit ;
    end ;

    if( ( Command[ 1 ] = '?' ) or ( Command[ 1 ] = 'H' ) ) then { Help }
    begin
	Do_Help ;
	Exit ;
    end ;

    if( Command[ 1 ] = 'I' ) then { INCLUDE command }
    begin
	Dummy := Pos( ' ', Command + ' ' ) ; { Find filename }
	Command := Copy( Command, Dummy + 1, Length( Command ) ) ;
	{ Get filename }
	TEU_Include( Command ) ;
	Exit ;
    end ;

    if( Copy( Command, 1, 1 ) = 'L' ) then { LOAD command }
    begin
	TEU_Load ;
	Exit ;
    end ;

    if( Command[ 1 ] = 'Q' ) then { QUIT command }
    begin
	TEU_Quit ;
	exit ;

    end ;

    if( Copy( Command, 1, 1 ) = 'R' ) then
    begin
	Exit ; { RESERVE command - ignored in editor }
    end ;

    if( Copy( Command, 1, 2 ) = 'SE' ) then { SET command }
    begin
	Dummy := Pos( ' ', Command + ' ' ) ;
	Command := Copy( Command, Dummy + 1, Length( Command ) ) ; { Strip SET }
	TEU_Set( Command ) ;
	Exit ;
    end ;

    if( Copy( Command, 1, 2 ) = 'SP' ) then { SPAWN command }
    begin
	TEU_Spawn ;
	Exit ;
    end ;

    if( Copy( Command, 1, 2 ) = 'ST' ) then { STORE command }
    begin
	TEU_Store ;
	Exit ;
    end ;

    if( Command[ 1 ] = 'W' ) then { WRITE command }
    begin
	TEU_Write ;
	Exit ;
    end ;

    Show_Error( 'Illegal command', True ) ;
end ; { Execute_Command }


procedure Teu_Search ; { Search for text }

begin
{$IFNDEF Simple}
    if( Recover_Terminating ) then { Abort if /RECOVER just finished }
    begin
	exit ;
    end ;
{$ENDIF}
    Select_Window( Error_Window ) ;
    Unmap_Window( Status_Window ) ;
    Writeln( Scr ) ;
    Write( Scr, 'Text to search for: ' ) ;
    Update_Window( Error_Window ) ;
    Do_Read ;
    if( Length( Kb_Buffer ) > 0 ) then { Something to search for }
    begin
	Fedit( Search_Text, Kb_Buffer, 32 ) ; { Get search text }
	Search ;
    end ;
end ;


procedure Teu_Special_Insert ; { Insert a character by ASCII value }

begin
    Character := Chr( Iterate ) ;
    Iterate := 0 ;
    Editor^.Insert_Chars( Character ) ; { Insert special character }
end ;


{$IFNDEF Simple}
procedure Dispatch( Key_Offset : integer; var Gold : integer ) ;
{ Dispatch a key command }

var Key : pKey_Definition ;

begin
    Key := Key_Commands[ Gold ]^[ Key_Offset ] ;
    if( Key^.Routine = 0 ) then
    begin
	if( Current_Key_Output <> nil ) then
	begin
	    Show_Error( 'Nested key definitions are not allowed', False ) ;
	    exit ;
	end ;
	Current_Key_Output := Key^.Definition ;
	Current_Key_Output^.Offset := 1 ;
	Key_Output := Key_Offset ;
	exit ;
    end ;
    if( Key^.Routine < 10 ) then { 9 shift levels possible }
    begin
	Gold := Key^.Routine ;
	exit ;
    end ;
end ;
{$ENDIF}


procedure TEU_UI ; { User interface to TEU }

label After_Prompt, Prompt ;

var A, B : Integer ; { Dummy variable }
    EOB : boolean ;
    Gold : integer ; { Shift level }
    Ord_C : Byte ;
    Scroll_Amount : integer ;
    S : string ;

begin
    Gold := 0 ;
Prompt:
    Scroll_Amount := Editor^.Screen_Column - Editor^.Cursor_Column ;
    if( Scroll_Amount > 0 ) then { Need to scroll left }
    begin
	Editor^.Scroll_Columns( -Scroll_Amount - 5 ) ;
    end ;
    Scroll_Amount := ( Editor^.Cursor_Column - Editor^.Screen_Column + 1 ) -
	Window_Width ;
    if( Scroll_Amount > 0 ) then { Need to scroll right }
    begin
	Editor^.Scroll_Columns( Scroll_Amount + 5 ) ;
    end ;
    if( Status ) then { Update status window }
    begin
        if( not Error_Flag ) then { No errors }
        begin
            if( not Window_Mapped( Status_Window ) ) then
            begin
                Map_Window( Status_Window, Screen_Height, 1, 1, Window_Width, 1, 1, 129 ) ;
                { Map window if not mapped }
            end ;
            Select_Window( Status_Window ) ;
            Write( Scr, 'Line: ', Editor^.Screen_Line + Editor^.Cursor_Row - 1 : 10, ' Column: ',
                Editor^.Cursor_Column : 3, Chr( 13 ) ) ; { Show position }
            Update_Window( Status_Window ) ;
            Select_Window( Editor^.Screen_Window )
        end ;
    end ;
    if( Editor^.Cursor_Column >= Window_Width + Editor^.Screen_Column - 1 ) then
    begin
	Set_Cursor( Editor^.Cursor_Row, Window_Width + 1 ) ;
    end else
    begin
	Set_Cursor( Editor^.Cursor_Row,
	    Editor^.Cursor_Column - Editor^.Screen_Column + 1 {2} ) ;
{ NOTE: the above line must have "+ 1" to work under DOS.  Possibly "+ 2" is
  needed for windows? }
    end ;
    Character := In_Key ; { Get next character }
    if( length( Character ) = 0 ) then { Shouldn't happen - but handle gracefully if it does }
    begin
        goto Prompt ;
    end ;
{$IFNDEF Simple}
    Recover_Terminating := False ; { Done terminating recovery }
{$ENDIF}
After_Prompt:
    if( Editor^.Cursor_Column >= Window_Width + Editor^.Screen_Column + 1 ) then
    begin
	Clear_Cursor( Editor^.Cursor_Row, Window_Width + 1 ) ;
    end else
    begin
	Clear_Cursor( Editor^.Cursor_Row,
	    Editor^.Cursor_Column - Editor^.Screen_Column + 1 ) ;
    end ;
    Show_Message( '', False ) ; { Clear any previous error messages }
    Error_Flag := False ; { No more error }
    Select_Window( Editor^.Screen_Window ) ;
    Ord_C := Ord( Character[ 1 ] ) ;

{$IFNDEF Simple}
    if( Key_Commands[ Gold ] <> nil ) then { Key shift set is defined }
    begin
	if( Key_Commands[ Gold ]^[ Ord_C ] <> nil ) then { Key is redefined }
	begin
	    Dispatch( Ord_C, Gold ) ;
	    goto Prompt ;
	end ;
    end ;
    if( Character = chr( 18 ) ) then { ^R = end recording key macro }
    begin
	if( Key_Input = nil ) then { Not recording keystrokes }
	begin
	    Show_Error( 'No keystokes are being recorded', False ) ;
	    goto Prompt ;
	end ;
	if( Key_Input^.Offset = 0 ) then { Nothing has been recorded }
	begin
	    Show_Error( 'No keystrokes were recorded', False ) ;
	    Dispose( Key_Input ) ;
	    Key_Input := nil ;
	    goto Prompt ;
	end ;
	Show_Message( 'Press the key to which to assign the keystrokes', False ) ;
	repeat
	    Character := Default_Input_InKey ;
	until( ( length( Character ) = 1 ) and ( Character <> chr( 13 ) ) ) ;
	Ord_C := ord( Character[ 1 ] ) ;

	{ Cancel any existing key definition for the specified key }
	Delete_Key_Command( 0, Ord_C ) ;

	{ Define new key }
	if( Maxavail < sizeof( tKey_Definition ) ) then { Ran out of memory }
	begin
	    Show_Error( '?Maximum memory exceeded', False ) ;
	    End_Edit ;
	    Halt ;
	end ;
	if( Key_Commands[ 0 ] = nil ) then
	begin
	    new( Key_Commands[ 0 ] ) ;
	    fillchar( Key_Commands[ 0 ]^, sizeof( tKey_Definition_Array ), 0 ) ;
	end ;
	new( Key_Commands[ 0 ]^[ Ord_C ] ) ;
	Key_Commands[ 0 ]^[ Ord_C ]^.Routine := 0 ; { Keystrokes }
	Key_Commands[ 0 ]^[ Ord_C ]^.Parameters := nil ;
	Key_Commands[ 0 ]^[ Ord_C ]^.Definition := Key_Input ;
	Key_Input := nil ;
	Show_Message( 'Keystrokes remembered', False ) ;
	goto Prompt ;
    end ;
    if( Character = chr( 11 ) ) then { ^K = start recording key macro }
    begin
	if( Key_Input <> nil ) then
	begin
	    Show_Error( 'Previous key macro recording must be finished', False ) ;
	    goto Prompt ;
	end ;
	if( Maxavail < sizeof( tKey_Definition ) ) then { Ran out of memory }
	begin
	    Show_Error( '?Maximum memory exceeded', False ) ;
	    End_Edit ;
	    Halt ;
	end ;
	new( Key_Input ) ;
	Key_Input^.Next := nil ;
	Key_Input^.Offset := 0 ;
	Key_Input^.Buffer := '' ;
	Current_Key_Input := Key_Input ;
	Show_Message( 'Enter the keystrokes to record, and press control-R to end', False ) ;
	goto Prompt ;
    end ;
{$ENDIF}
    if( ( Character = 'PF2' ) or ( Character = 'F2' ) or ( Character = 'F15' ) ) then { Help }
    begin
	Execute_Command( 'HELP' ) ;
	goto Prompt ;
    end ;
    if( Gold = 0 ) then
    begin
	if( Character = 'KP0' ) then { Advance a line }
	begin
	    Editor^.Advance ;
	    goto Prompt ;
	end ;
	if( Character = 'KP1' ) then { Move by word }
	begin
	    Editor^.Move_Word ;
	    goto Prompt ;
	end ;
	if( ( Character = 'KP2' ) or ( Character = 'F10' ) ) then { Go to end of line }
	begin
	    Editor^.Eol ;
	    goto Prompt ;
	end ;
	if( ( Character = 'KP6' ) or ( Character = 'CKP6' ) ) then { Cut }
	begin
	    Paste_Buffer^.Zero ;
	    Editor^.Copy_Text( Paste_Buffer ) ;
	    Editor^.Delete_Text ;
	    goto Prompt ;
	end ;
	if( Character = 'KP7' ) then { Advance one page }
	begin
	    Editor^.Page ;
	    goto Prompt ;
	end ;
	if( ( Character = 'KP8' ) or ( Character = 'F7' ) ) then { Page (half-page) }
	begin
	    Editor^.Half_Page ;
	    goto Prompt ;
	end ;
	if( ( Character = 'KP.' ) or ( Character = 'F8' ) ) then { Select }
	begin
	    Editor^.Select ;
	    goto Prompt ;
	end ;
	if( ( Character = 'KP,' ) or ( Character = 'F6' ) ) then
	{ Delete current character }
	begin
	    if( Editor^.At_EOB ) then
	    begin
		goto Prompt ; { Do nothing if at EOB }
	    end ;
	    Editor^.Cursor_Right ;
	    Deleted_Character := True ;
	    if( Editor^.Physical_Column = 1 ) then
	    begin
		Character_Buffer := CR ;
	    end else
	    begin
		Character_Buffer :=
		    Editor^.Physical_Text[ Editor^.Physical_Column - 1 ] ;
	    end ;
	    Editor^.Delete_Char( True ) ;
	    goto Prompt ;
	end ;
	if( ( Character = 'KP-' ) Or ( Character = 'F9' ) ) then { Delete word }
	begin
	    Deleted_Word := True ;
	    if( Editor^.At_EOL ) then
	    begin
		Editor^.Delete_Word ;
		Word_Buffer := CR ;
		goto Prompt ;
	    end ;

	    A := Editor^.Physical_Column ;
	    B := Editor^.Physical_Column ;
	    if(
                ( Editor^.Physical_Text[ B ] <> ' ' )
                and
		( Editor^.Physical_Text[ B ] <> HT )
              ) then { Starting on a non-white space character }
	    begin
		{ Skip to next white space character }
		while(
                       ( B <= Length( Editor^.Physical_Text ) )
                       and
		       ( Editor^.Physical_Text[ B ] <> ' ' ) { not space }
                       and
		       ( Editor^.Physical_Text[ B ] <> HT ) { not tab }
                     ) do
		begin
		    B := B + 1 ;
		end ;
	    end ;
	    if( A = B ) then { Move at least one character }
	    begin
		B := B + 1 ;
	    end ;
	    while(
                   ( B <= Length( Editor^.Physical_Text ) )
                   and
		   ( Editor^.Physical_Text[ B ] = ' ' )
                 ) do
	    begin
		{ Jump to next non-space character }
		B := B + 1 ;
	    end ;

	    Word_Buffer := Copy( Editor^.Physical_Text, A, B - A ) ;
	    { Deleted text }
	    Editor^.Delete_Word ;
	    goto Prompt ;
	end ;
	if( ( Character = 'PF3' ) or ( Character = 'F3' ) ) then
	{ Search for previous text }
	begin
	    Search ;
	    goto Prompt ;
	end ;
	if( ( Character = 'PF4' ) or ( Character = 'F4' ) ) then { Delete line }
	begin
	    if( Editor^.Current_Line <> nil ) then
	    begin
		Deleted_Line := True ;
		Line_Buffer :=
		    Copy( Editor^.Physical_Text, Editor^.Physical_Column, 255 ) ;
	    end ;
	    Editor^.Delete_Current_Line ;
	    goto Prompt ;
	end ; { if (Character = 'PF4') or (Character = 'F4') }
    end ;

    { Special characters after this point are gold-X }
    if( ( Character = 'KP.' ) or ( Character = 'F8' ) ) then { Unselect }
    begin
	Gold := 0 ;
	Editor^.Unselect ;
	goto Prompt ;
    end ;
    if( ( Character = 'KP,' ) or ( Character = 'F6' ) ) then
    { Undelete last deleted character }
    begin
	Gold := 0 ;
	if( Deleted_Character ) then
	begin
	    Editor^.Insert_Chars( Character_Buffer ) ; { Restore character }
	end ;
	goto Prompt ;
    end ;
    if( ( Character = 'KP-' ) or ( Character = 'F9' ) ) then { Undelete a word }
    begin
	Gold := 0 ;
	if( Deleted_Word ) then { A word to undelete }
	begin
	    Editor^.Insert_Chars( Word_Buffer ) ;
	end ;
	goto Prompt ;
    end ;
    if( ( Character = 'PF3' ) or ( Character = 'F3' ) ) then { Search }
    begin
	Gold := 0 ;
	TEU_Search ;
	goto Prompt ;
    end ;
    if( ( Character = 'PF4' ) or ( Character = 'F4' ) ) then { Undelete a line }
    begin
	Gold := 0 ;
	if( Deleted_Line ) then
	begin
	    EOB := Editor^.At_EOB ;
	    Editor^.Insert_Chars( Line_Buffer ) ; { A line to undelete }
	    if( EOB ) then
	    begin
		Editor^.Cursor_Right ; { Reposition to EOB }
	    end else
	    begin
		Character := CR ;
		Editor^.Insert_Chars( Character ) ;
	    end ;
	end ;
	goto Prompt ;
    end ;
    if( Character = 'KP0' ) then { Insert line }
    begin
	Gold := 0 ;
	Editor^.Insert_Blank_Line ;
	goto Prompt ;
    end ;
    if( Character = 'KP1' ) then { Change case }
    begin
	Gold := 0 ;
	Editor^.Change_Case ;
	goto Prompt ;
    end ;
    if( Character = 'KP3' ) then { Special insert }
    begin
	Gold := 0 ;
	Teu_Special_Insert ;
	goto Prompt ;
    end ;
    if( ( Character = 'KP4' ) Or ( Character = 'CKP4' ) ) then { Bottom of buffer }
    begin
	Gold := 0 ;
	Editor^.Bottom ;
	goto Prompt ;
    end ;
    if( ( Character = 'KP5' ) Or ( Character = 'F5' ) ) then { Top of buffer }
    begin
	Gold := 0 ;
	Editor^.Top ;
	goto Prompt ;
    end ;
    if( ( Character = 'KP6' ) or ( Character = 'CKP6' ) ) then { Paste }
    begin
	Gold := 0 ;
	Editor^.Paste( Paste_Buffer ) ;
	goto Prompt ;

    end ;
    if( ( Character = 'KP7' ) or ( Character = 'F16' ) ) then { Command }
    begin
	Gold := 0 ;
	Editor^.Do_Update ;
{$IFNDEF Simple}
	if( Recover_Terminating ) then { Abort if /RECOVER just finished }
	begin
	    goto Prompt ;
	end ;
{$ENDIF}
	Select_Window( Error_Window ) ;
	Unmap_Window( Status_Window ) ;
	Writeln( Scr ) ; { Clear any previous error messages }
	Write( Scr, 'Command: ' ) ; { Display prompt }
	Update_Window( Error_Window ) ;
	Do_Read ; { Get editing command }
	Fedit( Command, Kb_Buffer, 509 ) ; { Format it }
	Select_Window( Editor^.Screen_Window ) ;
	Execute_Command( Command ) ;
	Gold := 0 ;
	goto Prompt ;
    end ;
    if( Character = 'UP' ) then
    begin
	Gold := 0 ;
	Editor^.Cursor_Up ;
	goto Prompt ;
    end ;
    if( Character = 'DOWN' ) then
    begin
	Gold := 0 ;
	Editor^.Cursor_Down ;
	goto Prompt ;
    end ;
    if( Character = 'LEFT' ) then
    begin
	Gold := 0 ;
	Editor^.Cursor_Left ;
	goto Prompt ;
    end ;
    if( Character = 'RIGHT' ) then
    begin
	Gold := 0 ;
	Editor^.Cursor_Right ;
	goto Prompt ;
    end ;
    if( ( Character = 'PF1' ) Or ( Character = 'F1' ) ) then { Gold }
    begin
	Gold := 1 ;
	goto Prompt ;
    end ;
    if( Character = 'ENTER' ) then
    begin
	Gold := 0 ;
	goto Prompt ; { Ignore ENTER }
    end ;
    if( ( Gold = 1 ) and ( Character >= '0' ) and ( Character <= '9' ) ) then
    { GOLD number }
    begin
	Gold := 0 ;
	Select_Window( Error_Window ) ;
	Kb_Buffer := Character ;
	Write( Scr, Character ) ; { Show digit }
	while( ( Character >= '0' ) and ( Character <= '9' ) ) do
	{Until non-numeric entered}
	begin
	    Update_Window( Error_Window ) ; { show changes }
{$IFNDEF Simple}
	    if( Recover_Terminating ) then { Abort if /RECOVER just finished }
	    begin
		goto Prompt ; { Clear this state }
	    end ;
{$ENDIF}
	    Character := In_Key ; { Get next keystroke }
	    if( ( Character >= '0' ) and ( Character <= '9' ) ) then { A digit }
	    begin
		Write( Scr, Character ) ;
		Kb_Buffer := Kb_Buffer + Character ; { Append digit }
	    end else
	    if( ( Character = Chr( 127 ) ) or ( Character = Chr( 8 ) ) ) then
	    { Delete }
	    begin
		if( Length( Kb_Buffer ) = 0 ) then { Nothing left in buffer }
                begin
		    Message_Beep { Warning }
                end else
                begin
                    Write( Scr, Chr( 8 ), ' ', Chr( 8 ) ) ;
                    { Erase last digit }
                    Kb_Buffer := Copy( Kb_Buffer, 1, Length( Kb_Buffer ) - 1 )
                    { and remove it from the buffer }
                end ;
		Character := '0' ; { Fake digit so loop won't end }
	    end ;
	end ;
	Select_Window( Editor^.Screen_Window ) ;
	if( Length( Kb_Buffer ) = 0 ) then
	begin
	    goto After_Prompt ;
	end ;
	Val( Kb_Buffer, Iterate, B ) ;
	if( B <> 0 ) then { Some error }
	begin
	    Iterate := 0 ;
	    Message_Beep ;
	end ;
	goto After_Prompt ;
    end ;
    if( Length( Character ) > 1 ) then { Unknown special key }
    begin
	Gold := 0 ;
	Message_Beep ;
	goto Prompt ;
    end ;
    if( Ord_C = 3 ) then { Control-C }
    begin
	Show_Error( 'Control-C ignored', False ) ;
	Iterate := 0 ;
	goto Prompt ;
    end ;
    if( Character = '' ) then { Status }
    begin
	Iterate := 0 ;
	if( Editor^.Any_Changes ) then
	begin
	    S := '|Modified' ;
	end else
	begin
	    S := '' ;
	end ;
	Show_Message( 'TEU V' + Version + '|File: ' + Input_Name +
	    '|' + num1( Memavail ) + ' bytes available|' +
	    num1( Editor^.File_Root^.Last_Line ) + ' lines|' +
	    'Line,Column=' +
	    num1( Editor^.Screen_Line + Editor^.Cursor_Row - 1 ) + ',' +
	    num1( Editor^.Cursor_Column ) + S, True ) ;
	goto Prompt ;
    end ;
    if( Ord_C = 26 ) then { Control-Z }
    begin
	Editor^.Do_Update ;
	Execute_Command( 'EXIT' ) ;
	Exit ;
    end ;

    { Anything that follows will change the current line }
    if( ( Ord_C = 127 ) or ( Ord_C = 8 ) ) then { Delete }
    begin
	Deleted_Character := True ;
	if( Editor^.Physical_Column = 1 ) then
	begin
	    Character_Buffer := CR ;
	end else
	begin
	    Character_Buffer := Editor^.Physical_Text[ Editor^.Physical_Column - 1 ] ;
	end ;
	Editor^.Delete_Char_Back ;
	goto Prompt ;
    end ; { Delete }

    { Inserting character(s) }
    if( Iterate > 0 ) then { Iterative insert }
    begin
	while( Iterate > 0 ) do
	begin
	    if( Character <> Chr( 13 ) ) then { Must insert CRs one at a time }
	    begin
		if( Iterate > 255 ) then
		begin
		    Fillchar( Command[ 1 ], 255, Character[ 1 ] ) ;
		    Set_Length( Command, 255 ) ;
		    Iterate := Iterate - 255 ;
		end Else
		begin
		    Fillchar( Command[ 1 ], Iterate, Character[ 1 ] ) ;
		    Set_Length( Command, Iterate ) ;
		    Iterate := 0 ; { Done }
		end ;
		Editor^.Insert_Chars( Command ) ;
	    end Else
	    begin
		Iterate := Iterate - 1 ;
		Editor^.Insert_Chars( Character ) ; { Insert another CR }
	    end ;
	end ;
    end Else
    begin
	Editor^.Insert_Chars( Character ) ; { Insert a character }
    end ;
    goto Prompt ;
end ;


procedure Teu_Setup ;

begin
    Exitsave := Exitproc ;
    Exitproc := @Error ; { Set up error handler }
    Help_File_Name := File_Name( 'TEU.HLP' ) ;
{$IFNDEF Simple}
    Journal_Offset := 0 ;
    Journal_Record := 0 ;
    Journal_Size := 63 ;
    Iterate := 0 ;
{$ENDIF}
    Init_Smu( 0, 0, 0, 0 ) ; { Initialize for windowing }
    if( Get_Model = 2 ) then { DEC Rainbow }
    begin
	Write( '=' ) ; { Set keypad to application mode }
    end ;
    {Screen}
    Error_Window := Create_Window( 1, Window_Width, 4 ) ; { Error line }
    Status_Window := Create_Window( 1, Window_Width, 4 ) ; { Status line }
    Map_Window( Error_Window, Screen_Height, 1, 1, Window_Width, 1, 1, 128 ) ;
    Paste_Buffer := new( pLine_Buffer, Init ) ;
    Editor := new( pEditor, Init ) ;
    Editor^.Screen_Window := Create_Window( Screen_Height - 1, Window_Width, 4 or 8 ) ;
    Map_Window( Editor^.Screen_Window, 1, Screen_Height - 1, 1, Window_Width, 1, 1, 128 ) ;
    Editor^.Translation := Translation ;
    Editor^.Options := eds_SubWindow or eds_CursorBound or eds_Beep ;
    Editor^.Notification_Routine := Notify ;
    Assign( Init_File, File_Name( 'TEU.INI' ) ) ;
    { Find and assign initialization file }
    FileMode := 0 ;
    {$I-}
    Reset( Init_File ) ; { Open file }
    {$I+}
    FileMode := 2 ;
    if( Ioresult = 0 ) then { if success }
    begin
	while( not Eof( Init_File ) ) do
	begin
	    Readln( Init_File, Character ) ;
	    FEdit( Character, Character, 8 or 32 ) ;
	    { Uppercase and remove leading spaces }
	    if( ( length( Character ) > 0 ) and ( upcase( Character[ 1 ] ) = 'S' ) ) then
	    begin
		Execute_Command( Character ) ; { Do the command }
	    end ;
	end ;
	Close( Init_File ) { All done }
    end ;
end ;


procedure Teu_Teu( Command : string ) ; { Main routine }

label Main_Prompt, Start ;

var C, R : integer ;
    Temp : pLine_Buffer ;
    Work : string ;

begin
    if Length( Command ) > 0 then
    begin
	Ccl := True ;
    end Else
    begin
	Ccl := False ;
    end ;
    New_File := True ;
    Teu_Setup ; { Setup for processing }
    Select_Window( Editor^.Screen_Window ) ;
    Set_Window( Editor^.Screen_Window, Screen_Height - 1, 1, 0, 0 ) ;
    if( Ccl ) then
    begin
        goto Start ;
    end ;
    Set_Window( Editor^.Screen_Window, Screen_Height - 2, 1, 0, 0 ) ;
    Writeln( Scr, 'TEU V', Version, ' ', OS^.Name, ' V', OS^.Version, ' ', Date, ' at ', Time ) ;
    writeln( Scr ) ;
    Update_Window( Editor^.Screen_Window ) ;

    Command := File_Name( 'TEU.LFE' ) ; { Determine name of last file edited }
    Assign( Input_File, Command ) ;
    {$I-}
    Reset( Input_File ) ;
    {$I+}
    Dummy := Ioresult ;
    if( Dummy = 0 ) then { File is there }
    begin
	Readln( Input_File, Command ) ;
	Close( Input_File ) ;
	Select_Window( Error_Window ) ;
	Write( Scr, 'Editing file: ', Command, '.  Confirm <YES> : ' ) ;
	Update_Window( Error_Window ) ;
	Do_Read ;
	Kb_Buffer := Edit( Kb_Buffer, -1 ) ;
	if( ( Length( Kb_Buffer ) = 0 ) or ( Kb_Buffer[ 1 ] = 'Y' ) ) then
	begin
	    Select_Window( Editor^.Screen_Window ) ;
	    New_File := False ;
	    goto Start ;
	end ;
	Show_Message( '', False ) ; { Clear status line }
    end ;
Main_Prompt:
    Write( Scr, 'TEU> ' ) ; { Prompt user }
    Update_Window( Editor^.Screen_Window ) ;
    Window_Read ; { Get command line }
    Command := Kb_Buffer ;
    if( Length( Edit( Command, -1 ) ) = 0 ) then
    begin
	goto Main_Prompt ;
    end ;
    { Ignore blank lines }
    if(
        ( Kb_Buffer[ 1 ] = '' )
        or
        ( Kb_Buffer[ 1 ] = '' )
        or
	( Ord( Kb_Buffer[ 1 ] ) = 26 )
      ) then
    begin
	End_Edit ;
	halt ; { Abort on control-C/Y/Z }
    end ;
Start:
    Fedit( Input_Name, Command, 37 ) ; { Get name of file to edit }
    if( Parse_Switch( 'E|XIT', '', Input_Name, Work ) = 1 ) then
    begin
	halt ;
    end ;
    if( Parse_Switch( '?', '', Input_Name, Work ) = 1 ) then
    begin
	writeln( SCR, 'Command line format:' ) ;
	writeln( SCR ) ;
	writeln( SCR, 'TEU filename {switches}' ) ;
	writeln( SCR ) ;
	writeln( SCR, 'Valid switches:' ) ;
	writeln( SCR ) ;
	writeln( SCR, '    /HELP         Help for TEU.' ) ;
	writeln( SCR, '    /RECOVER      Recover from an aborted editing session' ) ;
	writeln( SCR, '    /READ_ONLY    Do not update file.' ) ;
	goto Main_Prompt ;
    end ;
    if( Parse_Switch( 'H|ELP', '', Input_Name, Work ) = 1 ) then
    begin
	Help( 'TEUEDIT', Work ) ;
	goto Main_Prompt ;
    end ;
{$IFNDEF Simple}
    case Parse_Switch( 'REC|OVER', 'NOREC|OVER', Input_Name, Work ) of
	1 : Recover := True ;
	else Recover := False ;
    end ;
    if( length( Work ) > 0 ) then
    begin
	writeln( SCR, 'Parameters not allowed on /RECOVER' ) ;
	goto Main_Prompt ;
    end ;
    Recover_Terminating := False ;
{$ENDIF}
    Dummy := Pos( '.', Command + '.' ) ; { Find input file extension }
    case Parse_Switch( 'REA|D_ONLY,NOW|RITE', 'NOREA|D_ONLY,W|RITE', Input_Name, Work ) of
	1 : Read_Only := True ;
	else Read_Only := False ;
    end ;
    if( length( Work ) > 0 ) then
    begin
	writeln( SCR, 'Parameters not allowed on /READ_ONLY' ) ;
	goto Main_Prompt ;
    end ;
{$IFNDEF Simple}
    if( Read_Only and Recover ) then
    begin
	writeln( SCR, '/RECOVER and /READ_ONLY are incompatible switches' ) ;
	goto Main_Prompt ;
    end ;
{$ENDIF}
    if( Switch_Present( Input_Name ) > 0 ) then
    begin
	writeln( SCR, 'Invalid switch: ', Input_Name ) ;
	goto Main_Prompt ;
    end ;
{$IFNDEF Simple}
    Journal_Name := Copy( Command, 1, Dummy - 1 ) + '.JOU' ;
    { Build journal file name }
{$ENDIF}

    if New_File then
    begin
	Assign( Input_File, 'TEU.LFE' ) ;
	{$I-}
	Rewrite( Input_File ) ;
	{$I+}
	if( Ioresult = 0 ) then { No problems }
	begin
	    Writeln( Input_File, Input_Name ) ; { Write edited filename }
	    Update_Window( Editor^.Screen_Window ) ;
	    Close( Input_File ) ;
	end ;
    end ;
    New_File := False ; { Assume existing file }
    Assign( Input_File, Input_Name ) ;
    FileMode := 0 ;
    {$I-}
    Reset( Input_File ) ; { Open it }
    {$I+}
    FileMode := 2 ;
    Dummy := Ioresult ;
    if( Dummy <> 0 ) then { Some error }
    begin
	if( Dummy = 2 ) then { File does not exist }
	begin
	    {$I-}
	    Rewrite( Input_File ) ; { Create file - it doesn't exit }
	    {$I+}
	    Dummy := Ioresult ;
	end ;
	if( Dummy <> 0 ) then { Error on creation }
	begin
	    Command := Ert( Dummy ) + ' - creating ' + Input_Name + '  ' ;
	    Select_Window( Error_Window ) ;
	    Write( Scr, Command ) ;
	    Update_Window( Error_Window ) ;
	    Select_Window( Editor^.Screen_Window ) ;
	    goto Main_Prompt ;
	end Else
	begin
	    New_File := True ; { No existing file }
	    Show_Error( 'Input file does not exist', True ) ;
	    Temp := new( pLine_Buffer, Init ) ;
	end ;
    end else { No error }
    begin
	Temp := new( pLine_Buffer, Init ) ;
	if( Include_File( Input_Name, Temp ) < 0 ) then { Out of memory }
	begin
	    End_Edit ;
	    halt ;
	end ;
	dispose( Editor^.File_Root, Done ) ;
    end ;
    Get_Window_Size( nil, R, C ) ; { Get screen size }
    Editor^.Resize ;
    Editor^.Set_Buffer( Temp ) ;
    Editor^.Redraw( 1 ) ;
    Close( Input_File ) ;
{$IFNDEF Simple}
    Assign( Journal, Journal_Name ) ;
    if( Recover ) then { if /RECOVER }
    begin
	{$I-}
	Reset( Journal ) ; { Open journal file }
	{$I+}
	A := Ioresult ;
	if( A <> 0 ) then
	begin
	    Select_Window( Error_Window ) ;
	    Message_Beep ;
	    Write( Scr, Ert( A ), ' - while opening journal file: ',
		Journal_Name, '.  Can''t recover.' ) ;
	    Update_Window( Error_Window ) ;
	    Select_Window( Editor^.Screen_Window ) ;
	    Recover := False ;
	end ;
	{$I-}
	Read( Journal, Journal_Buffer ) ;
	{$I+}
	if( Ioresult <> 0 ) then
	begin
	    Recover := False ; { Some error on read }
	end ;
    end ;
    if( not ( Recover or Read_Only ) ) then
    begin
	Rewrite( Journal ) ; { Create journal file }
    end ;
    if( Read_Only ) then
    begin
	Journal_Size := 0 ; { Turn journalling off }
    end ;
{$ENDIF}

    TEU_UI ; { Start user interface }
end ;


begin
    Set_Default_Screen_Height ;
{$IFNDEF Simple}
    Key_Input := nil ;
    Key_Output := -1 ;
    for Dummy := 0 to 9 do
    begin
	Key_Commands[ Dummy ] := nil ;
    end ;
{$ENDIF}
    Search_Text := '' ;
    Status := False ;
    Deleted_Line := False ;
    Deleted_Word := False ;
    Deleted_Character := False ;
    Init_SMU( 0, 0, 0, 0 ) ;
end.
