{
        Program Name : _FacMan
        Package Name : Subroutine Library - Layer 1
        Purpose      : Facility Manager pure virtual classes
        Institution  : Conroy & Conroy Co.
        Date Written : 1-April-2005
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 2005 by Alan Conroy.  Released to the Public Domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          The classes in this unit define the Facility Manager interface.
}

unit _FacMan ;

interface

uses { Layer 0... }
     COMInter, { TCommon_COM_Interface }
     Common ; { TBase_Object }

{$I EDEFINES.INC}

type TSFacility_Manager = object( TBase_Object )
                              public { Unit debugger support... }
                                  { Returns facility ID }
                                  function ID : longint ; virtual ;

                                  { Returns facility version }
                                  function Version : longint ; virtual ;

                                  { Construct an instance of the facility }
                                  function Construct : pointer ;
                          end ; { TSFacility_Manager }
     PSFacility_Manager = ^TSFacility_Manager ;

{$IFDEF DELPHI}
type TFacility_Manager = class( TBase_Delphi_Object )
                              public { Unit debugger support... }
                                  { Returns facility ID }
                                  function ID : longint ; virtual ; abstract ;

                                  { Returns facility version }
                                  function Version : longint ;
                                      virtual ; abstract ;

                                  { Construct an instance of the facility }
                                  function Construct : pointer ;
                                      virtual ; abstract ;
                          end ; { TSFacility_Manager }

type TCOM_Facility_Manager = class( TCommon_COM_Interface )
                              public { Unit debugger support... }
                                  { Returns facility ID }
                                  function ID : longint ;
                                      virtual ; stdcall ; abstract ;

                                  { Returns facility version }
                                  function Version : longint ;
                                      virtual ; stdcall ; abstract ;

                                  { Construct an instance of the facility }
                                  function Construct : pointer ;
                                      virtual ; stdcall ; abstract ;
                          end ; { TSFacility_Manager }
{$ENDIF}

implementation

uses { Layer 0... }
     _Common ; { Abstract_Error }

{ TSFacility_Manager methods... }

function TSFacility_Manager.ID : longint ;

begin
    ID := -1 ;
    Abstract_Error ;
end ;


function TSFacility_Manager.Version : longint ;

begin
    Version := -1 ;
    Abstract_Error ;
end ;


function TSFacility_Manager.Construct : pointer ;

begin
    Construct := nil ;
    Abstract_Error ;
end ;



end.

