{
        Program Name : _UEHDefs
        Package Name : Subroutine Library - Layer 1
        Purpose      : UEH definitions
        Institution  : Conroy & Conroy Co.
        Date Written : 10-Jan-1999
        Last Modified: 19-May-2002
        Written By   : Alan Conroy
        Version      : 1.2

        Copyright (C) 2002-2005 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

	  This unit provides definitions for UEH.
}

unit _UEHDefs ;

interface

{$I EDEFINES.INC}

uses { C&C Subroutine Library - layer 0 }
     _Common ; { TObject }

type tUEC = record { Unified Error Code }
                Facility : longint ;
                Code : longint ;
            end ;

{$IFDEF DELPHI}
type tError_Interface = class
                            public
                                function Get_Facility : longint ;
                                    virtual ; stdcall ; abstract ;
                                function Get_Name : PChar ;
                                    virtual ; stdcall ; abstract ;
                                function Translate_Error( Code : longint ) : PChar ;
                                    virtual ; stdcall ; abstract ;
                                procedure Done ; virtual ; stdcall ; abstract ;
                                function Facility_Version : longint ;
                                    virtual ; stdcall ; abstract ;
                                function Version : longint ;
                                    virtual ; stdcall ; abstract ;

                                { V1.2 support... }
                                function Severity( Code : longint ) : longint ;
                                    virtual ; stdcall ; abstract ;
                                function Translate_Error_Ex( Code : longint ;
                                    var Size, Typ : longint ) : PChar ;
                                    virtual ; stdcall ; abstract ;
                        end ;
{$ENDIF}

type TSError_Interface = object( TObject )
                             public
                                 function Get_Facility : longint ; virtual ;
                                 function Get_Name : string ; virtual ;
                                 function Translate_Error( Code : longint ) : string ;
                                     virtual ;
                                 function Facility_Version : longint ; virtual ;
                                 function Version : longint ;
                                     virtual ;
                                 function Severity( Code : longint ) : longint ;
                                     virtual ;
                                 function Translate_Error_Ex( Code : longint ;
                                     var Size, Typ : longint ) : string ;
                                     virtual ;
                         end ;
     PSError_Interface = ^TSError_Interface ;

const UEH_Success = 0 ;
const UEH_Informational = 1 ;
const UEH_Warning = 2 ;
const UEH_Error = 3 ;
const UEH_Fatal = 4 ;

implementation

{ tError_Interface methods... }

function tSError_Interface.Get_Facility : longint ;

begin
    Get_Facility := -1 ;
    Abstract_Error ;
end ;


function tSError_Interface.Get_Name : string ;

begin
    Get_Name := '' ;
    Abstract_Error ;
end ;


function tSError_Interface.Translate_Error( Code : longint ) : string ;

begin
    Translate_Error := '' ;
    Abstract_Error ;
end ;


function tSError_Interface.Facility_Version : longint ;

begin
    Facility_Version := 0 ;
    Abstract_Error ;
end ;


function tSError_Interface.Version : longint ;

begin
    Version := 0 ;
    Abstract_Error ;
end ;


function tSError_Interface.Severity( Code : longint ) : longint ;

begin
    Severity := UEH_Error ;
    Abstract_Error ;
end ;


function tSError_Interface.Translate_Error_Ex( Code : longint ;
    var Size, Typ : longint ) : string ;

begin
    Translate_Error_Ex := '' ;
    Abstract_Error ;
end ;



end.

